       PROGRAM metardeq
C
C**** *METARDEQ*
C 
C
C
C     PURPOSE.
C     --------
C         CONTROLLING ROUTINE FOR DECODING
C         METAR DATA.
C
C
C**   INTERFACE.
C     ----------
C
C         NONE.
C
C     METHOD.
C     -------
C
C          NONE.
C
C
C     EXTERNALS.
C     ----------
C
C        *CALL* *INITVAR( IERR )*
C        *CALL* *PROCRFB( IERR )*
C        *CALL* *PROCHDR( IERR )*
C        *CALL* *PROCTXT( IERR )*
C        *CALL* *PROCT1S( IERR )*
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          ROSANGELA CINTRA *CPTEC* 25/02/99.
C
C
      IMPLICIT LOGICAL(o,g), CHARACTER*8(C,H,Y)
C
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'combuff.h'
      INCLUDE 'comrec.h'
      INCLUDE 'comstat.h'
c
      common /reperr/ numreperr
      common /recwriten/ irecswriten
      common /repetida/ irepetida
      common /inil/ inil
c
c
      character*15 cstop
C
C     ------------------------------------------------------------------
C*          1.   INITIALIZE VARIABLES AND CONSTANTS.
C                ----------------------------------
 100  CONTINUE
c
      numbullerr = 0
      numreperr = 0
      irecswriten = 0
      irepetida = 0
c
C
      CALL INITVAR( IERR )
c     IF(IERR.NE.0) CALL EBEXIT(2)
C
C     ----------------------------------------------------------------
      OPEN(UNIT=99,FILE='metar.rdb',FORM='FORMATTED',
     1     STATUS='UNKNOWN')
C     ----------------------------------------------------------------
C
 200  CONTINUE
c
      ierr = 0
C     ------------------------------------------------------------------
      CALL READIN(IERR)
      IF(IERR.NE.0 .OR. IEOF.EQ.1) GO TO 1000
C     ------------------------------------------------------------------
C
      GO TO 200
C
C     ------------------------------------------------------------------
 1000 CONTINUE
C
      CLOSE(UNIT=99)
c
      numreport = 0
c
      do 15 i=1,26
         numreport = numreport + numrep(i)
 15   continue
c
      Open(UNIT=399,file='mesg_err.dat',STATUS='UNKNOWN')
C LAC status='old',access='append')
c
c--------------------------------------------------------------------------
      write(399,20)
      write(399,10)numbull,numbullerr,numreport,numreperr,
     c irecswriten,irepetida,inil
 10   format('| METAR     |','     ',I5,'     |',
     c       '     ',I5,'    ||',I5,'     |'
     c       ,I5,'     |',I5,'     |',
     c       I5,'     |',I5,'     |')
      write(399,20)
 20   format('|-----------|---------------|------------',
     c        '--||----------|----------|----------|---',
     c        '-------|----------|')
c
c------------------------------------------------------------------------------
      close(UNIT=399)
      STOP
      END
      SUBROUTINE READIN( IERR )
C
C**** *READIN*
C
C
C     PURPOSE.
C     --------
C         PURPOSE OF THIS ROUTINE IS TO READ IN ONE BULLETIN AT A TIME.
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *READIN( IERR )*
C
C
C     AUTHOR.
C     -------
C
C         ROSANGELA CINTRA *CPTEC* 23/02/99. 
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'combuff.h'
      INCLUDE 'comstat.h'
      INCLUDE 'compoin.h'
      INCLUDE 'comwt.h'
c     
      common /reperr/ numreperr
      common /recwriten/ irecswriten
      common /repetida/ irepetida
      common /inil/ inil
      common /comicao/ icao      
c
      integer file          
      character*45 infile,filein
      integer*4 k
      CHARACTER*32 arg
      external iargc,getarg
      integer  iargc
      character station*5,icao*4,ww*12
      CHARACTER YCHAR*16384
      integer iyymmddhh,dd,mm,aaaa,hh,mim,dir
      real rlon,rlat,rpres,rtt,rtd,rvel
      integer ww1,ww2,vis,st,nc,ncl,cl,hcl
            
C
C     ------------------------------------------------------------------
C*          1.   RESET ERROR INDICATOR, WORD AND BIT POINTERS.
C                ---------------------------------------------
      IERR= 0
c
C*          1.1  READ IN BULLETIN AND INCERMENT BULLETIN COUNTER.
C                ------------------------------------------------
C
C
      if (ieof .eq. 0) then
        k=iargc()
        if ( k .lt. 1) then
           infile ='metar.dat'
c            write (*,*) 'Usage mdb_metar.exe filein' 
c            stop
        else
         call getarg(1,infile)
        endif 
        
        OPEN(UNIT=3,IOSTAT=IOS,ERR=400,
     1     FILE=infile,
     1     STATUS='OLD')
     
        ieof = 2         
c        read(3,'(a)') titulo

        it = 0
      endif
      
100   continue
	read(3,33,err=800,end=301,iostat=ios)icao,station,rlat,rlon,
     *    aaaa,mm,dd,hh,min,rpres,rtt,rtd,dir,rvel,
     *    ww,ww1,ww2,vis,st,nc,ncl,cl,hcl  
 33     format(a4,1x,a5,2f7.2,1x,i4,2(1x,i2),1x,2(1x,i2),1x,f6.1,
     *   2(f5.1),1x,i3,f5.1,1x,a12,2(i3),1x,i5,1x,i1,1x,3(i2),i5)      
c      read(3,FMT=33,ERR=800,END=301,IOSTAT=IOS) icao,station,
c     &     rlat,rlon,dd,mm,aaaa,hh,mim,rpres,rtt,rtd,dir,rvel
c 33   format(a4,1x,a5,2(1x,f7.2),2(1x,i2),1x,i4,2(1x,i2),
c     &       1x,f6.1,2(1x,f5.1),1x,i3,1x,f5.1)
c      write(*,FMT=33,ERR=800,IOSTAT=IOS)icao,station,
c     &        rlat,rlon,dd,mm,aaaa,hh,mim,rpres,rtt,rtd,dir,rvel

       if (station .eq. '99999')go to 100
                 
c
c         latitude in hundreds of degree. All values positive.Sign
c         given by isglat 0-positive 1-negative
c
          isglat=0
          ilat=nint(rlat*100)
          if(ilat.lt.0) then
             isglat=1
             ilat=iabs(ilat)
          end if
c
c         longitude in hundreds of degree from 0-360
c
          ilon=nint(rlon*100)
          if(ilon.lt.0) ilon=36000-iabs(ilon)
c
        itemp = nint(rtt*10)
        itd = nint(rtd*10)
        iumrel = 99999
        ivvento = nint(rvel*10)
        idvento = dir*10
        ipres= nint(rpres*10)
c        print*,'itemp',itemp,' itd',itd,' ivvento',ivvento,' ipres',ipres,
c     &         ' idvento',idvento

 
       KDEC(4) = 16
       ISYYGG = 1
C
C          LOCATE YYGGIW GROUP.
c
           KINT(1) = MINDIC
           KINT(2) = MINDIC
           KINT(3) = MINDIC
C
C     IF LAND STATION REPORT EXTRACT 'YYGGIW' FROM 'MIMIMJMJ' LINE.
C
c           print*,dd,hh,min
           kint(1) = dd
           kint(2) = hh
           kdec(9) = min
           
              I = 0
              IF (KINT(1).LT.1.OR.KINT(1).GT.31)
     C             THEN
                       I = 1
                       KINT(1) = MINDIC
                   END IF
C
              IF ( KINT(2).LT.0.OR.KINT(2).GT.23)
     C             THEN
                       I = 1
                       KINT(2) = MINDIC
                   END IF
C               
              IF ( kdec(9).LT.0.OR.kdec(9).GT.59 )
     C             THEN
                       I = 1
                       KINT(3) = MINDIC
                   END IF

            if (i .ne. 0) then
             print*,'date error'
             print*, kint(1),kint(2),kdec(9)
            endif
C***
C*    DECODE REPORT .
C***
C
C     CONVERT REPORT TO INTERMEDIATE FORMAT.
C
      DO 101 I=4,300
         KINT(I) = MINDIC
  101 CONTINUE       

C
C     WORDS 9-13 SET TO CCITT.5 'XXX  ' ( 'X' = 88, 'SPACE' = 32 )
C     METAR IDENTIFIER RETAINED IN THESE WORDS IN CCITT 5 CHARS.
C
      DO 200 I=9,11
         KINT(I) = 88
  200 CONTINUE
C
      KINT(12) = 32
      KINT(13) = 32
      
           KINT(9)  = ichar(station(1:1))
           KINT(10) = ichar(station(2:2))
           KINT(11) = ichar(station(3:3))
           KINT(12) = ichar(station(4:4))
           KINT(13) = ichar(station(5:5))

       DO 303 I=1,3
         KDEC(I) = MINDIC
  303 CONTINUE
             
       DO 410 I=5,8
         KDEC(I) = MINDIC
410   CONTINUE
C
C     CLEAR FLAG FIELDS , RETAINING 'COR' FLAG.
C
      KDEC(13) = 0
C
C LAC      KDEC(15) = KDEC(15).AND.4
      KDEC(15) = AND(KDEC(15),4)
C
      DO 503 I=16,17
         KDEC(I) = MINDIC
  503 CONTINUE
C
C     CLEAR FLAG FIELDS , RETAINING 'COR' FLAG.
C
      KDEC(13) = 0
C
C LAC      KDEC(15) = KDEC(15).AND.4
      KDEC(15) = AND(KDEC(15),4)
C
      DO 500 I=16,17
         KDEC(I) = MINDIC
  500 CONTINUE
C
      KDEC(20) = 0
C
      DO 600 I=22,23
         KDEC(I) = MINDIC
  600 CONTINUE 
C***
C*    CONVERT SECTION 0 , WHICH IS DIFFERENT FOR LAND AND SEA
C*    STATIONS.
C***
C
  700 IF ( KDEC(4).EQ.16) then
C
C             LAND STATION .
c
c         station number
c
c          KINT(7) = 5
          
          read (station,'(i5.5)') kint(4)
          
          call locstat (iwind,iret)
           
          IF ( IRET.EQ.1 )
     C         THEN
C
C                     STATION NUMBER IN RANGE BUT NO MASTER FILE ENTRY
C                     ,SO REPORT IS IGNORED.
C
                      KERR=2
                      NOER(1,2)=NOER(1,2)+1
C
C-----                PRINT IIIII WITH NO MASTER FILE ENTRY
C-----
                WRITE (*,990) KINT(4)
 990            FORMAT (1H ,'NO MASTER FILE ENTRY - ',I5)
C-----
C-----                PRINT IIIII WITH NO MASTER FILE ENTRY
C
                      RETURN
                END IF
C
              IF (IRET.EQ.2 )
     C            THEN
C
C                     CORRUPT NUMBER   -   FATAL ERROR.
C
                      KPT=IABS(KPT)
C LAC                      KCHAR(KPT+5)=KCHAR(KPT+5).OR.128
                      KCHAR(KPT+5)=OR(KCHAR(KPT+5),128)
                      KERR = 2
                      
                  END IF
C
              IF (IRET.EQ.3) RETURN
C 
              IF ( KINT(3).EQ.MINDIC )
     C            THEN
C
C                     KNOTS
C
                      IF ( IWIND.EQ.0 ) KINT(3)=4
C
C                     METRES PER SECOND
C
                      IF ( IWIND.EQ.1 ) KINT(3)=1
                 END IF 
c          print*,kint(4),kdec(5),kdec(6),kint(3)
c          print*,kdec(8),kdec(15),kdec(16),kdec(17),kdec(23)

C
C                  LALALA
C
                   If ( isglat.eq.1) then 
                    KDEC(5) = -ilat
                    KINT(6) = kdec(5)
                   endif
C
C                  LOLOLOLO
C
                   If ( ilon.gt.18000) then
                    KDEC(6) = ilon -36000
                    KINT(8) = kdec(6)
                  endif
C***
C*    CONVERT SECTION 1 .
C***
C
C     IR IX H VV
C
C     IR   1 - 4 OR /
C
C
      KINT(14) = 4
      IF (KINT(14).LT.1.OR.KINT(14).GT.4.AND.KINT(15).GT.7.AND.
     C                KINT(15).NE.MINDIC) IRET = 1
C
      IF (IRET.NE.0 )
     C    THEN
              if (KINT(14).NE.MINDIC) IRET = 1
         end if
C
C     IX  1 - 7 OR /
C
      KINT(15) = 1
      IF (KINT(15).LT.1.OR.KINT(15).GT.7.AND.
     C                KINT(15).NE.MINDIC) IRET = 1
C
      IF (IRET.NE.0 ) KERR = 5
C
C     IF AUTO REPORT ALTER RDB CODE FIGURE .
C
      IF ( KINT(15).GE.4.AND.KINT(15).LE.7)
     C                  THEN
                            IF (KDEC(4).EQ.16) KDEC(4) = 14
                        END IF
C
C
C     N DD FF
C
       ivaz = 0
  
       if (ivvento .ne. 9999) then
        KINT(20) = iabs(ivvento/10)
       else
         ivaz = ivaz + 1
       endif
       if (idvento .ne. 9999) then
        KINT(19) = iabs(idvento/100)       
        else
         ivaz = ivaz + 1        
       endif

c
c      1SnTTT
c
       if (itemp .ne. 9999) then
          kint(23) = iabs(itemp)
          if (itemp .lt. 0) then
            kint(22) = 1
          else
            kint(22) = 0
          endif
       else
         ivaz = ivaz + 1 
       endif
c
c      2 Sn tdtdtd
c      calculo da temperatura no ponto de orvalho, segundo a formula
c        T-Td = 35(-logUw)--> td = t-35.* (-log(uw))
c

       if (itd .ne. 99999) then
          if (itd .lt. 0) then
            kint(25) = 1
          else
            kint(25) = 0
          endif
          kint(26) = iabs(itd)
       else
          ivaz = ivaz + 1
       endif
C
C              3 PPPP
C       
       if ( ipres .ne. 99999) then
          kint(30) = 0
          kint(31) = iabs(ipres)
       else
          ivaz = ivaz + 1
       endif

       KINT(40) = ichar(icao(1:1))
       KINT(41) = ichar(icao(2:2))
       KINT(42) = ichar(icao(3:3))
       KINT(43) = ichar(icao(4:4))
       
c      print*,'tt=',itemp,' td=',itd,' pp=',ipres
C
C
C*    VV   HORIZONTAL VISIBILITY
C
C
       if (vis .gt. 10000) then
        KINT(17) = mindic
        ivaz = ivaz+1
       else
         if (vis .eq. 10000) then
         kint(17) = 60
         else
         kint(17) = vis/100
         endif
       endif
C
C
C*    WW, Ww1, W12   PRESENT  WEATHER
C
C
        if (ww1 .ne. 999) then
         KINT(38) = ww1       
        else
         KINT(38) = mindic
         ivaz = ivaz + 1        
       endif
      
C
C***  N   TOTAL CLOUD COVER
C
C
      if ( nc .ne. 99) then
        kint(18) = nc
        KDEC(42)=KINT(18)
      else
          kint(18)=mindic
          ivaz = ivaz + 1
      endif
C
C***  NH   TOTAL LOW CLOUDS
C
C
      if ( ncl .ne. 99 .and. cl .ne. 0) then
        kint(42) = ncl
      else
          kint(42)=mindic
          ivaz = ivaz + 1
      endif
C
C
C***  CL, CM, CH   TYPE LOW MEDIUM AND HIGH CLOUDS
C
C

      if ( cl .ne. 99 .and. cl .ne. 0) then
        kint(44) = cl
      else
          kint(44)=mindic
          ivaz = ivaz + 1
      endif
      
C
C***  HH   HEIGHT OF THE BASE OF THE LOWEST CLOUD
C
      if ( hcl .ne. 99999) then
        kint(48) = hcl
      else
          kint(48) = mindic
          ivaz = ivaz + 1
      endif
  
      endif   ! kdec(4)=16    
C
C     CONVERT INTERMEDIATE TO DECODED FORMAT AND WRITE
C     TO FILE.
C
      if (ivaz .eq. 11) then
         inil = inil + 1
         NUMREP(1) = NUMREP(1) + 1 
         return
      endif     
c
      CALL SMDEC (IERR )
C
      IF ( KERR.NE.0 ) GO TO 111
C
      if(isaverr.ne.0) numreperr = numreperr + 1
       isaverr = 0
       kerr = 0
       ierr = 0
C
111   NUMREP(1) = NUMREP(1) + 1
C
202   CONTINUE                 
      go to 100

301   continue     
      ieof=1
      RETURN
C     -----------------------------------------------------------------             
800   CONTINUE
C
      IERR=1
      WRITE(*,9901) ios
      RETURN
C     -----------------------------------------------------------------
400   CONTINUE
C
      IERR=1
      WRITE(*,9903) IOS
      RETURN
C     ------------------------------------------------------------------
 9901 FORMAT(1H,'+ + + ERROR IN READING .IOSTAT=',I6)
 9903 FORMAT(1H,'+ + + ERROR IN OPENING UNIT 3. IOSTAT=', I6) 
c     ----------------------------------------------------------------
      END
      SUBROUTINE SMDEC (IERR )
C
C**** *SMDEC*
C
C
C     PURPOSE.
C     --------
C
C         DECODE SURFACE REPORT FROM INTERMEDIATE FORMAT
C         TO DECODED SURFACE REPORT
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *SMDEC(IERR)*
C
C          INPUT    :  REPORT IN INTERMEDIATE FORMAT IN KINT
C
C          OUTPUT   :  DECODED REPORT ON KDEC
C
C
C     EXTERNALS.
C     ----------
C
C         *CALL* *IC3333 (     )*      FOR LATTITUDE AND LONGITUDE
C         *CALL* *IT5TODC(     )*      CONVERSION FROM CITT5 TO DISPLAY CODE
C         *CALL* *IC0877 (     )*      WIND DIRECTION AND SPEED
C         *CALL* *IC4377 (     )*      HORIZONTAL VOISIBILITY
C         *CALL* *IC3845 (     )*      TEMPERATURE
C         *CALL* *IC1677 (     )*      HEIGHT OF BASE OF CLOUD  (HH)
C
C     MODIFICATIONS.
C     --------------
C
C          R. CINTRA
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'comindx.h'
C
C     ------------------------------------------------------------------
C           1. IN THIS SUBROUTINE THE ONLY PARTS OF THE HEADER
C              DECODED ARE IDENTIFIER , THE LENGTH OF REPORT ,
C              DAY OF THE MONTH AND TIME (HOUR & MIN) FROM REPORT
C              AND IN CASE OF SHIP OR BUOY
C              LAT, LONG, ALT=0
C
 100  CONTINUE
C
C
C     CLEAR ERROR INDICATOR.
C
      KERR = 0
      IERR = 0 
C
C*    SET DECODED REPORT TO MISSING DATA VALUE
C
      DO 1 I=25,120
      KDEC(I)=MINDIC
 1    CONTINUE

C
C*    IDENT   STATION  IDENTIFICATION NUMBER
C             KINT(12) - KINT(16) CONTAIN ID.
C
c      KDEC(7)=88
C
C
C*     DAY AND TIME
C
C      CHECK IF DAY AND HOUR ARE MISSING. IN THAT CASE USE 
C      DATE FROM ABBREVIATED HEADER.
C
       KDEC(1)=KINT(1)
       KDEC(2)=KINT(2)
C
       IF(KINT(1).EQ.MINDIC) THEN
                                KDEC(1)=KDEC(10)
                                IF(KDEC(10).EQ.MINDIC) RETURN
                             END IF
C
       IF(KINT(2).EQ.MINDIC) THEN
                                KDEC(2)=KDEC(11)
                                IF(KDEC(11).EQ.MINDIC) RETURN
                             END IF
C
      if (kdec(9) .eq. mindic) kdec(9) = 0
C
C*    SECTION 1
C
C
C*    DD & FF   WIND DIRECTION AND SPEED
C
C
      K=MINDIC
      K=KDEC(17)*1000 + KDEC(16)
120   CONTINUE
C
      if(kint(255).eq.0.and.kint(256).ne.mindic) then
         CALL IC0877(KINT(19),KINT(256),KINT(3),K,MINDIC,KDEC(25),
     1            KDEC(26))
      else
         CALL IC0877(KINT(19),KINT(20),KINT(3),K,MINDIC,KDEC(25),
     1            KDEC(26))
      end if
C
C
C*    VV   HORIZONTAL VISIBILITY
C
C
      CALL IC4377(KINT(17),MINDIC,KDEC(27))

C
C*    WW, W1, W2   PRESENT AND PAST WEATHER
C
C
      IF(KINT(38) .EQ. MINDIC .AND. (KINT(15) .EQ. 2 .OR.
     *                 KINT(15) .EQ. 5))
     *                     THEN
                              KDEC(28)=2
                              GO TO 210
                           END IF
C
C

      KDEC(28)=KINT(38)
c
210   CONTINUE
C
C*    TTT   AIR TEMPERATURE IN TENTHS OF DEGREE CELSIUS

      CALL IC3845(KINT(23),KINT(22),KDEC(16),KDEC(17),MINDIC,KDEC(31))

C*    TDTDTD   DEW POINT TEMPERATURE IN TENTHS OF DEGREE

      IF(KINT(26) .EQ. MINDIC) GO TO 320
      CALL IC3845(KINT(26),KINT(25),KDEC(16),KDEC(17),MINDIC,KDEC(32))

C
320   CONTINUE

C
C*    P0P0P0   PRESSURE AT STATION LEVEL IN TENTHS OF HECTOPASCAL

c      IF(KINT(28) .EQ. MINDIC) GO TO 340
c      KDEC(34)=KINT(28)
c      KK = KINT(28) / 1000
c      IF ( KK.EQ.0 ) KDEC(34) = KDEC(34) + 10000
c340   CONTINUE

C      CHECK IF THERE IS SEA LEVEL PRESSURE OR GEOPOTENTIAL IN THIS
C      THIS REPORT (IF A3 (=KINT(30)) .NE. 0 AND .NE. 9, THEN GEOPOT
C
C
      IF(KINT(30).EQ.MINDIC.OR.KINT(31).EQ.MINDIC ) GO TO 350
      IF(KINT(30) .NE. 0 .AND. KINT(30) .NE. 9) GO TO 350

C*    PRESSURE AT SEA LEVEL IN TENTHS OF HECTOPASCAL

      KDEC(35)=KINT(31) + 1000*KINT(30)
c      IF(KINT(30) .EQ. 0) KDEC(35)=KINT(31) + 10000

350   CONTINUE
C
C***  N   TOTAL CLOUD COVER
C
      KDEC(42)=KINT(18)
C
C***  NH   TOTAL LOW CLOUDS
C
      KDEC(44)=KINT(42)
c
C***  CL, CM, CH   TYPE LOW MEDIUM AND HIGH CLOUDS
C
      kdec(45)=KINT(44)
C
451   CONTINUE
C
C***  HH   HEIGHT OF THE BASE OF THE LOWEST CLOUD
C
      kdec(43)=kint(48)
c      CALL IC1677(KINT(48),MINDIC,KDEC(43))
C
455   CONTINUE
C
C
      CALL SYNEXP1( IERR )
      CALL QCSYNOP( 1,KDEC(4),KDEC(23),IERR )
      CALL BUFRENC( 1,IERR )
C

      RETURN
      END
c............................................................................      
      SUBROUTINE LOCSTAT ( IWIND,IRC )
C
C**** *LOCSTAT*
C
C
C     PURPOSE.
C     --------
C
C         EXTRACT PARTICULARS OF WMO OBSERVING STATIONS AND
C         PUT IN DECODED REPORT HEADER.
C
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *LOCSTAT(IWIND,IRC)*
C
C          INPUT    : ARGUMENTS NOT USED ON INPUT .
C
C                     KINT(4) - WMO STATION NUMBER IN INTEGER.
C                     KDEC(4) - INTEGER DENOTING OBSERVATION TYPE.
C
C          OUTPUT   : KDEC(5) - LATITUDE IN HUNDREDTHS OF DEGREES ,
C                               NORTH + , SOUTH - .
C                     KDEC(6) - LONGITUDE IN HUNDREDTHS OF DEGREES ,
C                               EAST + , WEST - .
C                     KDEC(8) - STATION PRESSURE ELEVATION (H/P) OR IF
C                               NONE EXISTS STATION GROUND ELEVATION (H/A).
C                               IF NEITHER EXIST MINDIC IS RETURNED . VALUE
C                               IS INTEGER IN METRES.
C
C                     KDEC(15) - IMPORTANT STATION OR GOOD QUALITY STATION
C                                FLAG BITS SET IN THIS WORD.
C
C                     KDEC(16) - WMO COUNTRY NUMBER , EXCLUDING FIRST 2
C                                DIGITS ( REGION NUMBER ) . INTEGER.
C                     KDEC(17) - WMO REGION NUMBER , INTEGER.
C
C                     KDEC(23) - PRESSURE LEVEL INDICATOR , INTEGER.
C                            0 = SEA LEVEL
C                            1 = STATION LEVEL
C                            2 = 850 HPA
C                            3 = 700 HPA
C                            4 = 500 HPA
C                            5 = 1000 GPM
C                            6 = 2000 GPM
C                            7 = 3000 GPM
C                            8 = 4000 GPM
C                            9 = 900 HPA
C
C                     IRC - INTEGER RETURN CODE
C                            0 = NO ERROR
C                            1 = STATION NUMBER NOT IN DIRECTORY
C                            2 = INVALID STATION NUMBER
C                            3 = INVALID OBSERVATION TYPE
C
C
C     EXTERNALS.
C     ----------
C
C         *CALL* *GBYTE(KS,KD,KBPT,KSI)*
C
C     MODIFICATIONS.
C     --------------
C          R. CINTRA
C
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'combuff.h'
C
C     ------------------------------------------------------------------
C*          1.   LOCATE STATION.                   .
C                ---------------
 100  CONTINUE
C
C     CLEAR ERROR RETURN INDICATOR
C
      IRC = 0
C
C     INITIALIZE TYPE OF STATION
C
      ITYPE = 0
C
C     'ITYPE' IS SET TO 4 FOR SYNOP , 2 FOR PILOT AND 1 FOR TEMP.
C
      IF ( KDEC(4).EQ.16.OR.KDEC(4).EQ.14 ) ITYPE = 4

C
      IF ( ITYPE.EQ.0 ) THEN
                            IRC = 3
                            RETURN
                        END IF
C
C     CHECK VALIDITY OF STATION NUMBER
C

      IF ( KINT(4).LE.1000.OR.KINT(4).GT.99999 )
     C                       THEN
                                 IRC = 2
                                 RETURN
                             END IF
C
C
C     LOCATE STARTING POINT IN ARRAY 'IPARAMS' OF THE WMO BLOCK
C     OF THE STATION.
C
C     EXTRACT WMO BLOCK NUMBER
C
      II = KINT(4) / 1000
C
C     WORD 'II' OF 'IPOINTS' SHOWS WHERE THE ENTRIES FOR BLOCK 'II'
C     START IN 'IPARAMS'.
C
      IND1 = IPOINTS(II)
      IND2 = IPOINTS(II+1)-3
c      if (ii .eq. 82  .or. ii .eq. 83) print*,'ind1/ind2=',ind1,ind2
C
C     STARTING AT THIS WORD A SEQUENTIAL SEARCH IS MADE FOR AN ENTRY
C     FOR THE REQUIRED STATION NUMBER ( III ) >
C
      III = KINT(4) - ( II * 1000 )
C
C     FOR ONE STATION ENTRY 3 WORDS ARE USED
C 
      DO 101 I=IND1,IND2,3
         CALL GBYTE(IPARAMS(I),ISTN,0,10)
         IF(ISTN.EQ.III) then
c           print*,' encontrou a estacao', istn,kint(4)
         GO TO 200
         endif
  101 CONTINUE
C
C     STATION NUMBER NOT FOUND
C
      IRC = 1
      RETURN
C
C
C     -----------------------------------------------------------------
C*             2.  EXTRACT REQUIRED PARAMETERS FROM 1ST WORD ENTRY.
C                  -----------------------------------------------
 200  CONTINUE
C
C     PRESSURE LEVEL CODE FIGURE
C
      IF(ITYPE .EQ. 4)
     C   CALL GBYTE(IPARAMS(I),KDEC(23),16,4)
C
C
C     WIND SPEED UNIT INDICATOR
C
      CALL GBYTE(IPARAMS(I),IWIND,20,1)
C
C
C     STATION ELEVATION
C
      CALL GBYTE(IPARAMS(I),KDEC(8),24,14)
      IF ( KDEC(8).GT.9999 ) KDEC(8) = KDEC(8)-16383
      IF ( KDEC(8).EQ.9999 ) KDEC(8) = MINDIC
      call gbyte(iparams(i+1),isgn,6,2)
      if(kdec(8).ne.mindic.and.isgn.eq.1) kdec(8)=-kdec(8)
C
C     LONGITUDE
C
      CALL GBYTE(IPARAMS(I+1),KDEC(6),8,16)
      IF ( KDEC(6).EQ.65535 ) KDEC(6) = MINDIC
      IF ( KDEC(6).NE.MINDIC.AND.KDEC(6).GT.18000)
     C      KDEC(6) = KDEC(6) - 36000
C
C
C     LATITUDE
C
      CALL GBYTE(IPARAMS(I+1),KDEC(5),24,14)
      IF ( KDEC(5).EQ.16383 ) KDEC(5) = MINDIC
      CALL GBYTE(IPARAMS(I+2),ISGN,6,1)
      IF(ISGN.EQ.1.AND.KDEC(5).NE.MINDIC)
     C                KDEC(5) = -KDEC(5)
C
C
C     WMO REGION NUMBER
C
      CALL GBYTE(IPARAMS(I+2),KDEC(17),8,3)
      IF ( KDEC(17).EQ.0 ) KDEC(17) = 8
C
C
C     WMO COUNTRY NUMBER ( LAST 3 DIGITS )
C
      CALL GBYTE(IPARAMS(I+2),KDEC(16),11,10)
C
C
C     IMPORTANT STATION AND GOOD QUALITY FLAGS.
C
      CALL GBYTE(IPARAMS(I+2),ISGQ,24,2)
      KDEC(15) = KDEC(15).OR.ISGQ
C
C
C     CHECK THAT PARAMETERS ARE VALID FOR OBSERVATION TYPE REQUESTED.
C     SOME STATIONS HAVE MORE THAN 1 ENTRY , DEPENDING ON TYPE OF
C     OBSERVATION.
C
      IF(ITYPE.EQ.1) ISKIP=26
      IF(ITYPE.EQ.2) ISKIP=27
      IF(ITYPE.EQ.4) ISKIP=28
C
      CALL GBYTE(IPARAMS(I+2),ITP,ISKIP,1)
      IF (  ITP.NE.0 ) RETURN
C
C     PARAMETERS NOT CORRECT FOR CODE TYPE , SO USE NEXT ENTRY
C     IF IT EXIST
C
      I = I + 3
C
      CALL GBYTE(IPARAMS(I),ISTN,0,10)
      IF(ISTN.EQ.III) GO TO 200
C
C     RETAIN ALREADY EXTRACTED PARAMETERS
C     THAT MEAN THAT STATION TYPE DOES NOT CORRESPOND TO THE MESSAGE
C     RECEIVED. 
C     
      RETURN

      END
c..........................................................................
      SUBROUTINE IC2700(ICODE,ICOVER)
C
C**** *IC2700*
C
C
C     PURPOSE.
C     --------
C         TO CONVERT CODE TABLE 2700 INTO PERCENTAGE CLOUD COVERAGE.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *IC2700(ICODE,ICOVER)*
C
C
C     AUTHOR.
C     -------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
C
C
C     MODIFICATIONS.
C     --------------
C
C          R.CINTRA
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      DIMENSION ICT(10),IPR(10)
      DATA ICT/ 0, 1, 2, 3, 4, 5, 6, 7, 8, 9/
      DATA IPR/ 0,10,25,40,50,60,75,90,100,999999/
C
C     ------------------------------------------------------------------
C*          1.   CONVERT CLOUD COVERAGE IN OKTAS INTO PERCENTAGE.
C                ------------------------------------------------
 100  CONTINUE
C
      DO 101 I=1,10
C
      IF(ICODE.EQ.ICT(I)) THEN
                             ICOVER=IPR(I)
                             GO TO 200
                          END IF
 101  CONTINUE
C
      ICOVER=999999
C
 200  CONTINUE
C
      RETURN
      END 

c............................................................................      
      SUBROUTINE IC0777(IDD,ITEMP,MINDIC,IDEWPT)
C
C****
C*
C*    NAME     :  IC0777
C*
C*    FUNCTION :  DECODE DEW-POINT TEMPERATURE IN TENS OF DEGREE
C*
C*    INPUT    :  IDD     - DEW-POINT EPRESSION
C*             :  ITEMP   - TEMPERATURE
C*             :  MINDIC  - MISSING DATA VALUE
C*
C*    OUTPUT   :  IDEWPT  - DECODED DEW-POINT TEMPERATURE
C*
C*             IDEWPT IS SET TO MISSING VALUE IF
C*             ANY ERRORS FOUND IN IDD
C*
C*   A.HOLOPAINEN  JAN.83
C*
C****
C
C
C
C***   CHECK MISSING DATA INDICATOR
C
      IF(IDD .EQ. MINDIC) RETURN
C
      IF(ITEMP .EQ. MINDIC) RETURN
C
C     CHECK THE RANGE OF IDD
C
      IF(IDD .LT. 0 .OR. IDD .GT. 99) RETURN
C
      IF(IDD .GT. 51 .AND. IDD .LE. 55) RETURN
C
C
      IDEW=IDD
      IF(IDD .GE. 56) IDEW=10 * (IDD - 50)
C
      IDEWPT=ITEMP - IDEW
C
      RETURN
      END
c............................................................................      
      SUBROUTINE IC0877(IDD,IFF,IWW,ICOUNT,MINDIC,IDIR,ISPEED)
C
C****
C*
C*    NAME     :  IC0877
C*
C*    FUNCTION :  DECODE WIND DIRECTION AND SPEED
C*
C*    INPUT    :  IDD     - WIND DIRECTION IN TENS OF DEGREE
C*             :  IFF     - WIND SPEED
C*             :  IWW     - WIND SPEED INDICATOR , CODE TABLE 1855
C*             :  ICOUNT  - COUNTRY NUMBER
C*             :  MINDIC  - MISSING DATA VALUE
C*
C*    OUTPUT   :  IDIR    - DECODED WIND DIRECTION
C*                ISPEED  - DECODED WIND SPEED
C*
C*             IDIR AND ISPEED ARE SET TO MISSING VALUE IF
C*             ANY ERRORS FOUND IN IDD, IFF OR IWW
C*
C****
C
C***   SET MISSING VALUE
C
      IDIR=MINDIC
      ISPEED=MINDIC
C
C
C
C***   CHECK MISSING DATA INDICATOR
C
      IF(IWW .EQ. MINDIC .OR. IDD .EQ. MINDIC .OR.
     1   IFF .EQ. MINDIC) RETURN
C
C     CHECK IF WIND INDICATOR IR IS CORRECT
C
      IF(IWW .NE. 0 .AND. IWW .NE. 1 .AND. IWW .NE. 3
     1  .AND. IWW .NE. 4) RETURN
C
C
C     IW IS THE MODIFIED WIND SPEED INDICATOR TO MAKE
C     IF-STATEMENTS SHORTER
C        IW=0 FOR METER/SEC
C        IW=1 FOR KNOTS
C
      IW=(IWW-1)/2
      ISPEED=IFF
      IDIR=IDD
C
C
C     CHECK IF DD=99 .I.E. DIRECTION INDETERMINATE
C
C
C     CHECK IF DD INDICATOR IS SENSIBLE
C
      IF(IDIR .GT. 36 .AND. IDIR .LT. 50) RETURN
      IF(IDIR .GT. 86 .AND. IDIR .NE. 99) RETURN
C
C     CHECK IF SHIP OR BUOY, BECAUSE THEN THERE IS NO COUNT NUMBER
C
      IF(ICOUNT .EQ. MINDIC)
     *    THEN
             IF(IDIR .GT. 50 .AND. IDIR .NE. 99) ISPEED=ISPEED+100
             GO TO 100
          END IF
C
C
C     CHECK IF THE DATA IS FROM U.S.S.R.
C
      IF(ICOUNT .EQ. 6310 .OR. ICOUNT .EQ. 2010)
     1        THEN
                   IF(ISPEED .EQ. 77) ISPEED=20
                   IF(ISPEED .EQ. 88) ISPEED=40
                 ELSE
                   IF(IDIR .GT. 50 .AND. IDIR .NE. 99) ISPEED=ISPEED+100
              END IF
C
100   CONTINUE
C
C     IF SPEED IN KNOTS MODIFY TO M/S
C
      IF(IW .EQ. 1) CALL KTOMPSI(ISPEED)
      IF(IDIR .GT. 50 .AND. IDIR .NE. 99) IDIR=IDIR-50
      IF(IDIR .EQ. 99) IDIR=62
C
      IDIR=IDIR*10
C
      RETURN
      END
c................................................................................      
      SUBROUTINE IC1600(INHEI,LOWEST,MINDIC,OUTHEI)
C
C****
C*
C*    NAME     :  IC1600
C*
C*    FUNCTION :  DECODE THE HEIGHT OF LOWEST CLOUDS
C*
C*    INPUT    :  INHEI   - CODE FIGURE FOR THE HEIGHT
C*                LOWEST  - INDICATOR FOR LOWEST CLOUD
C*                          0 = LOW CLOUD
C*                          1 = MEDIUM CLOUD
C*                          2 = HIGH CLOUD
C*                MINDIC  - MISSING DATA VALUE
C*
C*    OUTPUT   :  OUTHEI  - DECODED HEIGHT OF LOWEST CLOUDS IN METRES
C*
C*             OUTHEI SET TO MISSING VALUE
C*             IF ANY ERRORS FOUND IN INHEI
C*
C****
C
      INTEGER OUTHEI
C
      DIMENSION IHEIGHT(12)
C
      DATA IHEIGHT/25,75,150,250,450,800,1250,1750,2250,2600,3500,8000/
C
C***   SET MISSING VALUE
C
      OUTHEI=MINDIC
C
C***   TEST THE VALIDITY OF THE CODE FIGURE
C
      IF(INHEI .EQ. MINDIC .OR. LOWEST .EQ. MINDIC) RETURN
C
      IF(INHEI .LT. 0 .OR. INHEI .GT. 9) RETURN
C
C
C     FOR N = 9 DEFAULT HEIGHTS ARE ALLOCATED DEPENDING ON
C     WHETHER LOWEST CLOUD IS LOW, MEDIUM OR HIGH.
C
      IF ( INHEI.NE.9 ) LOWEST = 0
C
      IND=INHEI + 1 + LOWEST
      OUTHEI=IHEIGHT(IND)
      RETURN
      END
c.............................................................................    
      SUBROUTINE IC3845(INTEMP,ISIGN,ICOUNT,IREG,MINDIC,OUTTEMP)
C****
C*
C*    NAME     : IC3845
C*
C*    FUNCTION :  DECODE THE TEMPERATURE
C*
C*    INPUT    :  INTEMP   TEMPERATURE VALUE
C*                ISIGN    SIGN INDICATOR FOR TEMPERATURE
C*                         0 = NOT NEGATIVE, 1 = NEGATIVE
C*                ICOUNT  COUNTRY NUMBER.
C*                IREG  REGION NUMBER.
C*                MINDIC   MISSING DATA VALUE
C*
C*    OUTPUT   :  OUTTEMP  OUTPUT TEMPERATURE WITH CORRECT SIGN
C*
C*             OUTTEMP IS SET TO MISSING VALUE
C*             IF ANY ERRORS FOUND IN INTEMP
C*
C****
C
      INTEGER OUTTEMP
C
C***   SET MISSING VALUE
C
      OUTTEMP=MINDIC
C
C
C     TEST FOR MISSING DATA AND VALIDITY OF SIGN
C
      IF(INTEMP .EQ. MINDIC .OR. ISIGN .EQ. MINDIC) RETURN
      IF(ISIGN .LT. 0 .OR. ISIGN .GT. 1) RETURN
C
      OUTTEMP=INTEMP
      IF(ISIGN .EQ. 1) OUTTEMP = -1*OUTTEMP
C
      RETURN
C     TEMPERATURE IS GIVEN IN FAHRENEIT IN CUBA,NICARAGUA AND PANAMA
C     ( REGION 4 COUNTRY NUMBERS 70,170 AND 190 ) AND HAS TO BE
C     CONVERTED TO CELSIUS.
C
C      IF ( IREG.NE.4 ) RETURN
C      IF ( ICOUNT.NE.70.AND.ICOUNT.NE.170.AND.ICOUNT.NE.190) RETURN
C      CALL FTOC2 ( OUTTEMP )
C
C
C      RETURN
      END
c.............................................................................      
      SUBROUTINE IC4377(INVIS,MINDIC,OUTVIS)
C
C****
C*
C*    NAME     :  IC4377
C*
C*    FUNCTION :  DECODE HORIZONTAL VISIBILITY AT SURFACE VV
C*
C*    INPUT    :  INVIS   -VISIBILITY CODE FIGURE
C*                MINDIC  - MISSING DATA VALUE
C*
C*    OUTPUT   :  OUTVIS  -DECODED VISIBILITY IN METRES
C*
C*             OUTVIS IS SET TO MISSING DATA VALUE
C*             IF ANY ERRORS FOUND IN INVIS
C*
C****
C
C
C
      INTEGER OUTVIS
      DIMENSION IVISIB(9)
C
      DATA IVISIB /50,200,500,1000,2000,4000,10000,20000,55000/
C
C***   SET OUTVIS TO MISSING VALUE
C
      OUTVIS=MINDIC
C
      IF(INVIS .EQ. MINDIC) RETURN
      IF(INVIS .GE. 51 .AND. INVIS .LE. 55) RETURN
      IF(INVIS .LT. 0 .OR. INVIS .GT. 99) RETURN
C
      IF(INVIS .EQ. 89) THEN
                              OUTVIS=75000
                              RETURN
                           END IF
C
      IF(INVIS .EQ. 90) THEN
                              OUTVIS=25
                              RETURN
                           END IF
C
      IF(INVIS .EQ. 0) THEN
                             OUTVIS=50
                             RETURN
                           END IF
C
C
      IF(INVIS .GE. 1 .AND. INVIS .LE. 50)
     1       THEN
                 OUTVIS=100 * INVIS
                 RETURN
             END IF
C
      IF(INVIS .GE. 56 .AND. INVIS .LE. 80)
     1       THEN
                 OUTVIS=(INVIS - 50) * 1000
                 RETURN
             END IF
C
      IF(INVIS .GE. 81 .AND. INVIS .LE. 88)
     1       THEN
                 OUTVIS=(INVIS - 80) * 5000 + 30000
                 RETURN
             END IF
C
      IF(INVIS .GE. 91 .AND. INVIS .LE. 99)
     1       THEN
                 IND=INVIS-90
                 OUTVIS=IVISIB(IND)
                 RETURN
             END IF
C
C
      RETURN
      END
c...........................................................................      
      SUBROUTINE IC3333(IQUADR,LAT,LONG,MINDIC,LAT2,LONG2)
C
C****
C*
C*    NAME     :  IC3333
C*
C*    FUNCTION :  DECODE LATITUDE AND LONGITUDE GIVEN IN THE FORM
C*                99LALALA QCL0L0L0L0
C*
C*    INPUT    :  IQUADR   THE QUADRANT OF THE GLOBE (QC)
C*             :  LAT      LATITUDE IN TENTHS OF DEGREE
C*             :  LONG     LONGITUDE IN TENTHS OF DEGREE
C*             :  MINDIC   MISSING DATA VALUE
C*
C*
C*    OUTPUT   :  LAT2   LATITUDE IN HUNDREDTHS OF DEGREE
C*                       SOUTHERN LATITUDE NEGATIVE
C*             :  LONG2: LONGITUDE IN HUNDREDTHS OF DEGREE
C*                       WESTERN LONGITUDE NEGATIVE
C*
C*                LAT2 AND LONG2 ARE SET TO MISSING DATA VALUE IF
C*                ANY ERRORS FOUND IN LAT,LONG OR QUADRANT
C*
C****
C
C
      DIMENSION LATSIGN(4),LONSIGN(4)
C
      DATA LATSIGN/ 1,-1,-1, 1/
      DATA LONSIGN/ 1, 1,-1,-1/
C
C***  SET LAT2 AND LONG2 TO MISSING DATA VALUE
C
      LAT2=MINDIC
      LONG2=MINDIC
C
C
C     THE ARRAYS LATSIGN AND LONSIGN ARE USED TO DETERMINE IF
C     LAT. AND LONG. ARE NEGATIVE OR POSITIVE
C
C     CHECK THAT THE QUADRANT IS CORRECT
C
      IF(IQUADR .NE. 1 .AND. IQUADR .NE. 3 .AND. IQUADR .NE.
     1     5 .AND. IQUADR .NE. 7) RETURN
C
C     CHECK THAT THE LATITUDE AND LONGITUDE ARE SENSIBLE
C
      IF(LAT .LT. 0 .OR. LAT .GT. 900) RETURN
C
      IF(LONG .LT. 0 .OR. LONG .GT. 1800) RETURN
C
C
      IQ=(IQUADR+1)/2
C
      LAT2=10*LAT*LATSIGN(IQ)
      LONG2=10*LONG*LONSIGN(IQ)
C
      RETURN
      END
c...............................................................................
      SUBROUTINE IC1677(ICODE,MINDIC,IHEIGHT)
C
C****
C*    NAME     : IC677
C*
C*    FUNCTION :  DECODE THE HEIGHT OF THE BASE OF THE
C*                LOWEST CLOUD  HH OR HSHS
C*
C*    INPUT    :  ICODE    CODE NUMBER FOR THE HEIGHT
C*                MINDIC   MISSING DATA VALUE
C*
C*    OUTPUT   :  IHEIGHT   DECODED HEIGHT IN METRES
C*
C*             IHEIGHT SET TO MISSING VALUE
C*             IF ANY ERRORS FOUND IN ICODE
C*
C****
C
      DIMENSION IHSHS(9)
C
      DATA IHSHS/25,75,150,250,450,800,1250,1750,2250/
      
C***  SET MISSING VALUE
C
      IHEIGHT=MINDIC
C
      IF(ICODE .LT. 0 .OR. ICODE .GT. 98) RETURN
c
      IF(ICODE .EQ. 89) THEN
                 IHEIGHT=22000
                 RETURN
                 END IF
c
      IF(ICODE .LE. 50) THEN
                 IHEIGHT=ICODE*30+15
                 IF(IHEIGHT .LT. 0) IHEIGHT=0
                 RETURN
                 END IF
C
      IF(ICODE .GE. 56 .AND. ICODE .LE. 80) THEN
                 IHEIGHT=(ICODE-50)*300+150
                 RETURN
                 END IF
C
      IF(ICODE .GE. 81 .AND. ICODE .LE. 88) THEN
                 IHEIGHT=(ICODE-80)*1500+9750
                 RETURN
                 END IF
C
C     CODE VALUE 99 IS NOT USED FOR HH, ONLY FOR HSHS
C     AND FOR TIME BEING 99 IS NOT DECODED AT ALL.
C
      IF(ICODE .GE. 90) THEN
                           IND=ICODE-89
                           IHEIGHT=IHSHS(IND)
                           RETURN
                        END IF
C
C
      END
c...............................................................................
      SUBROUTINE DDFFF(IDD,IFF,IWW,ICOUNT,MINDIC,IDIR,ISPEED)
C
C**** *DDFFF*
C
C
C     PURPOSE.
C
C
C         DECODE WIND DIRECTION AND SPEED
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *DDFFF(IDD,IFF,IWW,ICOUNT,MINDIC,IDIR,ISPEED)*
C
C          INPUT    :  IDD     - WIND DIRECTION IN TENS OF DEGREE
C                   :  IFF     - WIND SPEEDIN METERS/SEC OR KNOTS
C                   :  IWW     - WIND SPEED INDICATOR (1 FOR KNOTS)
C                   :  ICOUNT  - COUNTRY NUMBER
C                   :  MINDIC  - MISSING DATA VALUE
C
C          OUTPUT   :  IDIR    - DECODED WIND DIRECTION
C                      ISPEED  - DECODED WIND SPEED
C
C              IDIR AND ISPEED ARE SET TO MISSING VALUE IF
C              ANY ERRORS FOUND IN IDD, IFF OR IWW
C     AUTHOR.
C     -------
C
C          A.HOLOPAINEN  JAN.83
c
C     MODIFICATIONS.
C     --------------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
C          R>CINTRA
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)

C     ------------------------------------------------------------------
C*          1.   DECODE WIND DIRECTION AND SPEED.
C                --------------------------------
 100  CONTINUE
C
C      CHECK MISSING DATA INDICATOR
C
      IF(IDD .EQ. MINDIC .OR. IFF .EQ. MINDIC) RETURN
C
C     CHECK IF IDD ID FEASABLE
C
      IF(IDD .LT. 0 .OR. IDD .GT. 36) RETURN
C
      ISPEED=IFF
      IDIR=IDD
C
C
C     CHECK IF DD=99 .I.E. DIRECTION INDETERMINATE
C
C
C     CHECK IF DD INDICATOR IS SENSIBLE
C
      IF(IDIR .GT. 36 .AND. IDIR .LT. 50) RETURN
      IF(IDIR .GT. 86 .AND. IDIR .NE. 99) RETURN
C
C
C
C
      IF(IDIR .GT. 50 .AND. IDIR .NE. 99) IDIR=IDIR-50
      IF(IDIR .EQ. 99) IDIR=62
C
      IDIR=IDIR*10
C
      IF(ISPEED .GE. 500) THEN
                             ISPEED=ISPEED-500
                             IDIR=IDIR+5
                            END IF
C
C
C     IF SPEED IN KNOTS MODIFY IT TO M/S
C
      IF(IWW .EQ. 1) CALL KTOMPSI(ISPEED)
C
      RETURN
      END
      
      SUBROUTINE INITVAR ( IERR )
C
C**** *INITVAR*
C
C
C     PURPOSE.
C     --------
C         DECLARATION OF COMMON AREAS AND INITIALISATION OF
C         VARIABLES.
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *INITVAR(IERR)*
C
C           IERR - SET TO 0 .
C
C     AUTHOR.
C     -------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
C
C
C     MODIFICATIONS.
C     --------------
C
C          R. CINTRA
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
c
      INCLUDE 'parameter.h'
C
      CHARACTER *10 IFA
      CHARACTER CUNIT*24,CVAL*9
      character*256 stdname,croot
C
      CHARACTER*8 YDATE
      CHARACTER*5 YTIME,YFAMILY,YTASK
C
      COMMON /BCOMROOT/ CROOT
C
C            CROOT    -  path for Bufr tables
C
      INCLUDE 'combuff.h'
      INCLUDE 'comwork.h'
      INCLUDE 'comindx.h'
      INCLUDE 'comstat.h'
      INCLUDE 'compoin.h'
      INCLUDE 'comwt.h'
      INCLUDE 'comwtc.h'
      INCLUDE 'comstd.h'
      include 'comdate.h'
      
       EXTERNAL GETENV
C
C     ------------------------------------------------------------------
C           1.   INITIALISE MISSING DATA INDICATOR.
C                ----------------------------------
 100  CONTINUE
C
      DATA MINDIC / '17777777777'O /
      OPS2=.TRUE.
      NSUB=0
C     -------------------------------------------------------------------
C*          2.   INITIALIZE DEFAULT VALUES FOR ERROR HANDLING OPTIONS.
C                ------------------------------------------------------
 200  CONTINUE
C                'IOPTS' CONTAINS 1 WORD FOR ANY POSSIBLE
C                 BULLETIN TYPE FROM 'TT' OF 'AA' TO 'ZZ' .
C                 BIT SETTINGS HAVE THE FOLLOWING MEANING.
C                 BITS ARE NUMBERED LEFT TO RIGHT , 59 TO 0 .
C
C                 BIT N  = 1 MEANS REPORT WITH ERROR NUMBER N+1 IS TO BE
C                            WRITTEN TO THE ERROR FILE .
C                          0 MEANS REPORT NOT TO BE WRITTEN TO ERROR FILE.
C
C
C
C
C                 WORDS 677 AND 678 DEFINE DEFAULT OPTIONS FOR HANDLING OF
C                 BULLETIN ERRORS.
C
C                 WORD 678 : BIT N = 1 MEANS BULLETIN WITH ERROR N+1 IS TO BE
C                                      WRITTEN TO THE ERROR FILE.
C                 WORD 677 : BIT N = 1 MEANS BULLETIN WITH ERROR N+1 IS TO BE
C                                      PRINTED.
C                 NO ACTION IF BIT N = 0 .
C
C
C                 DEFAULT FOR HANDLING REPORT ERRORS IS TO WRITE
C                 ALL REPORTS WITH ERRORS TO THE ERROR FILE.
C
C                 DEFAULT BULLETIN HANDLING IS TO DISCARD 'NIL' BULLETINS ,
C                 SHORT ( LESS THAN 3 LINES ) BULLETINS AND NATIONAL
C                 BULLETINS FROM UK AND FRG. BULLETINS IN ERROR ARE NOT
C                 PRINTED.
C
      DATA IOPTS / 676*'17777777777'O,'0'O,'2'O /
C
C     -------------------------------------------------------------------
C*          3.    CLEAR COUNTERS.
C                 ---------------
 300  CONTINUE
C
C                 NUMBULL : NUMBER OF BULLETINS HANDLED BY DECODING RUN.
C                 NUMBERR : NUMBERS OF BULLETIN ERRORS.
C                 NOER    : NUMBERS OF REPORT ERRORS.
C                 NUMREP  : NUMBERS OF REPORTS HANDLED BY DECODING RUN.
C
      DATA NUMBULL / 0 /
      DATA NUMREP /26*0/
      DATA NUMBERR / 8*0 /
      DATA NOER /1560*0/
      DATA NUMRERR /26*0/
      DATA IMPSTA/2000*0/
      DATA IGRIBS /0/
C
C     -------------------------------------------------------------------
C*          4.   SET END OF FILE INDICATOR.
C                ---------------------------
 400  CONTINUE
C
      DATA IEOF / 0 /
C     -------------------------------------------------------------------
C*          5.   INITIALIZE ERROR INDICATOR.
C                ---------------------------
 500  CONTINUE
C
      IERR = 0
C     -----------------------------------------------------------------
C*          6.   SET UP NUMBER OF BITS PER COMPUTER WORD.
C                ----------------------------------------
 600  CONTINUE
C
      NBPW=32
      NWPT=1
C     -----------------------------------------------------------------
C*          7.   SET UP BIT MASKS.
C                -----------------
 700  CONTINUE
C
      DATA ( MASKS(J),J=1,32)/
     1                             '1'O,                      '3'O,
     2                             '7'O,                     '17'O,
     3                            '37'O,                     '77'O,
     4                           '177'O,                    '377'O,
     5                           '777'O,                   '1777'O,
     6                          '3777'O,                   '7777'O,
     7                          '7777'O,                  '37777'O,
     8                         '77777'O,                 '177777'O,
     9                        '377777'O,                 '777777'O,
     A                       '1777777'O,                '3777777'O,
     1                       '7777777'O,               '17777777'O,
     2                      '37777777'O,               '77777777'O,
     3                     '177777777'O,              '377777777'O,
     4                     '777777777'O,             '1777777777'O,
     5                    '3777777777'O,             '7777777777'O,
     6                   '17777777777'O,            '37777777777'O  /
C
C     ------------------------------------------------------------------
C*          8.   SET UP BUFR TABLE B.
C                --------------------
 800  CONTINUE
C
      CROOT=' '
      CALL GETENV('BUFR_TABLES',CROOT)
      ILNG=INDEX(CROOT,' ')
      IF(ILNG.EQ.1) then
         CROOT='./'
      endif   
         ILNG=INDEX(CROOT,' ')-1
      

      WRITE(*,'(1H ,A)') 'Your path for Bufr tables is :'
      WRITE(*,'(1H ,A)')  CROOT(1:ilng)
C      
      CALL SETTAB( IERR )
C     --------------------------------------------------------------------
C*          9.   SET UP WMO STATION LIST AND IMPORTANT STATIONS.
C                -----------------------------------------------
 900  CONTINUE
C
      CALL STATION(IERR)
C     --------------------------------------------------------------------
C*          10.   SET UP date of observations.
C                -----------------------------------------------
 905  CONTINUE
C
      call datim (ny,nm,nd,nutc,nh,nmin,nsec,ncc)

      if (nm .lt. 0) nm = nm * -1     
c       print*,'initvar',ny,nm,nd        
C     --------------------------------------------------------------------
C*          10.   SET UP HEIGHT AND PRESSURE OF STANDARD ATMOSPHERE.
C                ---------------------------------------------------
1000  CONTINUE
C
      
      stdname=croot(1:ilng)//'standard_atmosphere.dat '
      ii=INDEX(stdname,' ')-1
      print*,stdname(1:ii)

      OPEN(UNIT=11,IOSTAT=IOS,ERR=1005,
     1     FILE=stdname,
     1     READONLY,
     1     STATUS='OLD')
C
      DO 1001 I=1,512
      READ(11,FMT=7777,ERR=1010,END=1100,IOSTAT=IOS)  SH(I),P(I)
 7777 FORMAT(1X,F5.0,2X,F8.2)
 1001 CONTINUE
C
      CLOSE(11)
C
      GO TO 1100
C
 1005 CONTINUE
C
      PRINT*,' Open error ',ios,' on file standard_atmosphere.dat'
C
 1010 CONTINUE
C
      PRINT*,' Read error ',ios,' on file standard_atmosphere.dat'
C
C
C*            11. GET SUPERVISOR DATE,TIME,FAMILY AND TASK.
C                 -----------------------------------------
 1100 CONTINUE
C
C      READ(*,'(A8,A5,A5,A5)') YDATE,YTIME,YFAMILY,YTASK
C
      RETURN
      END

      SUBROUTINE STATION(IERR)
C
C**** *STATION*
C
C
C     PURPOSE.
C     --------
C         READ IN STATION LIST AND MAKE LIST OF IMPORTANT STATIONS.
C         ( WMO VOLUMEN A - LIST OF OBSERVING STATIONS)
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *STATION(IERR)*
C
C     EXTERNALS.
C     ----------
C
C         *CALL* *IMPSTAT*
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
C
C
C     MODIFICATIONS.
C     --------------
C
C          R.CINTRA
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'combuff.h'
C
      COMMON /BCOMROOT/ CROOT
C
C            CROOT    -  path for Bufr tables
C
      character*256  croot,sname
C     ------------------------------------------------------------------
C*          1.   READ IN STATION LIST.
C                ---------------------
      ios = 0
 100  CONTINUE
C
      ILNG=INDEX(CROOT,' ')-1
      sname=croot(1:ilng)//'station_list.dat'
      ii=INDEX(sname,' ')-1
      print*,sname(1:ii)
      
      OPEN(UNIT=4,IOSTAT=IOS,ERR=300,
     1     FILE=sname(1:ii),
     1     READONLY,
     1     STATUS='OLD',
     1     FORM='UNFORMATTED')
C
C
      READ(4) IPARAMS,IPOINTS
c      do i = 1,128
c      print*,i,ipoints(i)
c      enddo

      CLOSE(4)
C
C
C*           2.  FIND IMPORTANT STATIONS.
C                ------------------------
 200  continue
 
      CALL IMPSTAT
C
      RETURN
C
 300  CONTINUE
C
      WRITE(*,9901) IOS
 9901 FORMAT(1H ,' ERROR DURING OPENING  STATION FILE , ERROR=',I5)

      RETURN
      END
      
      SUBROUTINE IMPSTAT
C
C**** *IMPSTAT*
C
C
C     PURPOSE.
C     --------
C
C         DEFINES FROM WMO MASTER FILE THE SATION NUMBERS
C         FOR IMPORTANT STATIONS (ECMWF INTERNAL DEFINOTIONS)
C
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *IMPSTAT*
C
C             INPUT     : IPARAMS   STATION INFORMATION IN PACKED FORM
C                         IPOINTS   NUMBER OF STATION / WMO BLOCK
C
C             OUTPUT    : IMPSTA    THE NUMBERS OF IMPORTATNT SATIONS
C
C     MODIFICATIONS.
C     --------------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
c	   R.CINTRA
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'combuff.h'
C
C
C     ------------------------------------------------------------------
C*          1.   FIND IMPORTANT STATIONS.
C                ------------------------
C
      J = 0
      K = 1
C
C
            DO 300 I = 1,33000,3
C
            IF(IPARAMS(I) .EQ. MINDIC) RETURN
            IF(I .LT. IPOINTS(K+1)) GO TO 200
C
100         K = K + 1
            IF(K .GE. 99) RETURN
            IF(IPOINTS(K) .EQ. IPOINTS(K+1)) GO TO 100
C
200         CONTINUE
C
            CALL GBYTE(IPARAMS(I+2),ITEMP,28,1)
            CALL GBYTE(IPARAMS(I+2),IBIT ,25,1)
C
           IF(ITEMP .EQ. 1 .AND. IBIT .EQ. 1)
     C         THEN
                  CALL GBYTE(IPARAMS(I),III,0,10)
                  ISTA= 1000*K+ III
                  IF(J .NE. 0)
     C               THEN
                        DO 250 N=1,J
                        IF(ISTA .EQ. IMPSTA(N)) GO TO 300
250                     CONTINUE
                     END IF
                  J = J + 1
                  IF(J.GT.2000) THEN
                     PRINT*,'DIMENSION IF IMPSTA TOO SMALL'
                     RETURN
                  END IF
C
                  IMPSTA(J) = ISTA
               END IF
C
300        CONTINUE

      RETURN
      END
      
      SUBROUTINE PRTKDEC(IA,K,J,MINDIC)
C
C**** *PRTKDEC*
C
C
C     PURPOSE.
C     --------
C         PRINTS THE DECODED FORMAT ARRAY (KDEC)
C         OF DECODING DATA (PHASE II).
C
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *PRTKEDEC(IA,K,J,MINDIC)*
C
C         INPUT     : IA     - THE 'KDEC' ARRAY
C                      K      - PRINT STARTS AT WORD I.
C                      J      - PRINT STOPS AT WORD J .
C                      MINDIC - MISSING VALUE INDICATOR
C
C     MODIFICATIONS.
C     --------------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/08/88.
C
C
       IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
C
       DIMENSION IA(1)
C
C     ------------------------------------------------------------------
C
C*          1.   PRINT ARRAY 'KDEC'.
C                -------------------
 100  CONTINUE
C
C
C
      LODATA = .TRUE.
      LODOT = .TRUE.
C
      WRITE(*,10000)
10000 FORMAT(1H ,2X,'  DATA IN DECODED FORMAT ( KDEC ) ',/)
C
C
         DO 101 I=K,J,10
         I2 = I+9
C
            DO 102 JJ=I,I2
            IF(IA(JJ) .EQ. MINDIC) GO TO 102
            LODATA = .FALSE.
102         CONTINUE
C
         IF(LODATA) THEN
C
C                      CHECK IF THERE ARE MORE DATA
C
                       DO 103 JJ=I2,J
                       IF(IA(JJ) .EQ. MINDIC) GO TO 103
                       GO TO 104
103                    CONTINUE
                       RETURN
C
104                    CONTINUE
C
                       IF(LODOT) THEN
                                    WRITE(*,20000)
20000                               FORMAT(1H ,3X,'---',/1H ,3X,'---')
                                    LODOT = .FALSE.
                                 END IF
                       GO TO 101
                    END IF
C
         LODOT = .TRUE.
         LODATA = .TRUE.
C
         IF(I .EQ. 1)  WRITE(*,30000) I,(IA(IK),IK=I,I2)
         IF(I .EQ. 11) WRITE(*,40000) I,(IA(IK),IK=I,I2)
         IF(I .GT. 20) WRITE(*,50000) I,(IA(IK),IK=I,I2)
30000    FORMAT(1H ,2X,I4,4X,6(I10,1X),6X,A4,1X,3(I10,1X))
40000    FORMAT(1H ,2X,I4,4X,2(I10,1X),O10,1X,I10,1X,O10,1X,2(I10,1X),
     C          2(I10,1X),I10)
50000    FORMAT(1H ,2X,I4,4X,10(I10,1X))
C
101      CONTINUE

      RETURN
      END
      
      SUBROUTINE PRTKINT(IA,K,KL,MINDIC)
C
C**** *PRTKINT*
C
C
C     PURPOSE.
C     --------
C         PRINTS THE INTERMEDIATE FORMAT ARRAY (KINT)
C         OF DECODING DATA (PHASE II).
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *PRTKINT(IA,K,J,MINDIC)*
C
C         INPUT     : IA     - THE 'KINT' ARRAY
C                     K      - PRINT STARTS AT WORD I.
C                     KL      - PRINT STOPS AT WORD J .
C                     MINDIC - MISSING VALUE INDICATOR
C     MODIFICATIONS.
C     --------------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      DIMENSION IA(1)
C
C     ------------------------------------------------------------------
C
C*          1.   PRINT ARRAY 'KINT'.
C                -------------------
 100  CONTINUE
C
C
      LODATA = .TRUE.
      LODOT = .TRUE.
C
C
      WRITE(*,10000)
10000 FORMAT(1H ,2X,'  DATA IN INTERMEDIATE FORMAT ( KINT ) ',/)
C
C
         DO 101 I=K,KL,10
         I2 = I+9
C
            DO 102 J=I,I2
            IF(IA(J) .EQ. MINDIC) GO TO 102
            LODATA = .FALSE.
102         CONTINUE
C
         IF(LODATA) THEN
C
C                      CHECK IF THERE ARE MORE DATA
C
                       DO 103 J=I2,KL
                       IF(IA(J) .EQ. MINDIC) GO TO 103
                       GO TO 104
103                    CONTINUE
                       RETURN
C
104                    CONTINUE
C
                       IF(LODOT) THEN
                                    WRITE(*,20000)
20000                               FORMAT(1H ,3X,'---',/1H ,3X,'---')
                                    LODOT = .FALSE.
                                 END IF
                       GO TO 101
                    END IF
C
         LODOT = .TRUE.
         LODATA = .TRUE.
C
         WRITE(*,30000) I,(IA(J),J=I,I2)
30000    FORMAT(1H ,2X,I4,2X,10(I10,1X))
C
C
101      CONTINUE
C
      RETURN
      END
      
      SUBROUTINE SYNEXP1(IERR )
C
C**** *SYNEXP1*
C
C
C     PURPOSE.
C     --------
C         SET UP BUFR EXPANDED FORMAT FOR SYNOP DATA.
C         BASIC REPORT. 
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *SYNEXP1(IERR)*
C
C     EXTERNALS.
C     ----------
C
C         *CALL* *DATUM(I,J,K)*
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
C
C
C     MODIFICATIONS.
C     --------------
C
C          R.CINTRA
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'compoin.h'
      INCLUDE 'comtab.h'
      INCLUDE 'comwt.h'
C
      CHARACTER*9 CVAL
      CHARACTER*24 CUNIT
      integer date_time(8)

C
      INCLUDE 'comwtc.h'
      INCLUDE 'comkey.h'
      include 'comdate.h'
      common /retarda/ iretarda
      
      integer ndeltatime
      external ndeltatime
C
      CHARACTER*9 CIDENT
      character*4  icao
      
      INCLUDE 'comkeyc.h'
C
      common /comicao/icao
C     ------------------------------------------------------------------
C*          1.   INCREASE COUNTER OF SUBSETS BY ONE.
C                -----------------------------------
 100  CONTINUE
C
      IF(IERR.NE.0) RETURN
C
      NSUB=0
      NSUB=NSUB+1
      Ns  =NSUB
C
      DO 101 I=1,900
      DO 102 J=1,2
      VALUES(I,J)=999999.
102   CONTINUE
101   CONTINUE 
C
C*          1.1  GET CURRENT DATE (YEAR AND MONTH).
C                ----------------------------------
 110  CONTINUE
C
      CALL DATUM(KDEC(1),IMONTH,IYEAR)
C     ------------------------------------------------------------------      
c        verificando o numero de mensagens com mais de 
c        48 horas de atraso na recepcao.
c
c      call datim (date_time)
      icen = iyear*.01        
      NY1=iYEAR - (icen *100)      
      idhj = (ny1*1000000)+(nm*10000)+(nd*100)
      id48 = NDELTATIME(Idhj,-48)
      idob = (ny1*1000000)+(imonth*10000)+(kdec(1)*100)
      if (idob .le. id48) then
          iretarda = iretarda + 1
      endif
C
C     ------------------------------------------------------------------
C*          2.   SYNOP - LAND BASED STATION.
C                --------------------------
 200  CONTINUE
C
      IF(KDEC(4).EQ.16.OR.
     1   KDEC(4).EQ.14    ) THEN
        kdec(23) = 1
C     -----------------------------------------------------------------
C*          2.1  SYNOP LAND ( MANUAL/AUTOMATIC) STATION.
C                ----------------------------------------
C                LOW ALTITUDE STATION.
C                ---------------------
 210  CONTINUE
C
      IF(KDEC(23).GT.1) GO TO 230
C
      VALUES( 1,NSUB)=(KINT( 9)-48)*10+KINT(10)-48
      VALUES( 2,NSUB)=(KINT(11)-48)*100+(KINT(12)-48)*10
     1                +KINT(13)-48
       VALUES( 3,NSUB)=999999.
       IF(KDEC(4).EQ.16) VALUES(3,NSUB)=1.
       IF(KDEC(4).EQ.14) VALUES(3,NSUB)=0.
       VALUES( 4,NSUB)=FLOAT(IYEAR)
       VALUES( 5,NSUB)=FLOAT(IMONTH)
       VALUES( 6,NSUB)=FLOAT(KDEC(1))
       VALUES( 7,NSUB)=FLOAT(KDEC(2))
       VALUES( 8,NSUB)=FLOAT(KDEC(9))
       VALUES( 9,NSUB)=KDEC(5)/100.
       VALUES(10,NSUB)=KDEC(6)/100.
       VALUES(11,NSUB)=999999.
       IF(KDEC(8).NE.MINDIC) VALUES(11,NSUB)=FLOAT(KDEC(8))
       VALUES(12,NSUB)=999999.
       IF(KDEC(35).NE.MINDIC) VALUES(12,NSUB)=KDEC(35)*10.
       VALUES(13,NSUB)=999999.
       IF(KDEC(25).NE.MINDIC) VALUES(13,NSUB)=FLOAT(KDEC(25))
       VALUES(14,NSUB)=999999.       
       IF(KDEC(26).NE.MINDIC) VALUES(14,NSUB)=FLOAT(KDEC(26))
       VALUES(15,NSUB)=999999.
       IF(KDEC(31).NE.MINDIC)
     1    VALUES(15,NSUB)=KDEC(31)/10.+273.16
       VALUES(16,NSUB)=999999.
       IF(KDEC(32).NE.MINDIC)
     1    VALUES(16,NSUB)=KDEC(32)/10.+273.16
       VALUES(17,NSUB)=999999.
       IF(KDEC(27).NE.MINDIC) VALUES(17,NSUB)=FLOAT(KDEC(27))
       VALUES(18,NSUB)=999999.
       IF(KDEC(28).NE.MINDIC)
     1    THEN
             VALUES(18,NSUB)=FLOAT(KDEC(28))
             IF(KDEC(4).EQ.14)VALUES(18,NSUB)=FLOAT(KDEC(28))+100.
          END IF
       VALUES(19,NSUB)=999999.
        CALL IC2700(KDEC(42),ICOVER)
       VALUES(19,NSUB)=FLOAT(ICOVER)
       VALUES(20,NSUB)=1.
       VALUES(21,NSUB)=999999.
       IF(KDEC(44).NE.MINDIC) VALUES(21,NSUB)=FLOAT(KDEC(44))
       VALUES(22,NSUB)=999999.
       IF(KDEC(45).NE.MINDIC)
     1    THEN
             VALUES(22,NSUB)=FLOAT(KDEC(45))+30.
          ELSE
             VALUES(22,NSUB)=63.
          END IF
       VALUES(23,NSUB)=999999.
       IF(KDEC(43).NE.MINDIC) VALUES(23,NSUB)=FLOAT(KDEC(43))       
C
C      UPDATE NUMBER OF ELEMENTS.
C
       M=23   
C
C*          2.2   SET INFORMATION NEEDED FOR RDB KEY DEFINITION.
C                 ----------------------------------------------
 220  CONTINUE
C
      NBUFTYPE=0
      NTYPE=1                           ! SURFACE DATA
      IF(KDEC(4).EQ. 16) NSBTYPE=6      ! METAR LAND
C
C

      NYEAR =IYEAR
      NMONTH=IMONTH
      NDAY  =KDEC(1)
      NHOUR =KDEC(2)
      NMINUTE=KDEC(9)
      NSECOND=0
C
      JSCALE=5
      JREFLAT= -9000000
      JREFLON=-18000000
C
      NLAT1=NINT(VALUES( 9,NSUB)*10.**JSCALE)-JREFLAT
      NLON1=NINT(VALUES(10,NSUB)*10.**JSCALE)-JREFLON
c
      NLAT2=0  
      NLON2=0
C
      NOBS=NSUB
C
      CIDENT= CHAR(KINT(09))//CHAR(KINT(10))//CHAR(KINT(11))//
     1        CHAR(KINT(12))//CHAR(KINT(13))//'    '
c      icao = char(kint(40))//char(kint(41))//char(kint(42))//
c     1        char(kint(43))

C
      NRECR=1
C
       RETURN
C
C*          2.3  SYNOP LAND ( MANUAL/AUTOMATIC) STATION.
C                ----------------------------------------
C                HIGH ALTITUDE STATION.
C                ---------------------
 230  CONTINUE
C
       RETURN
      END IF
C
      IERR=1
C
      RETURN
      END
      
      SUBROUTINE BUFRENC(K,IERR )
C
C**** *BUFRENC*
C
C
C     PURPOSE.
C     --------
C         PURPOSE OF THIS ROUTINE IS TO ENCODE INDIVIDUAL SYNOP
C         REPORT FROM FULLY EXPANDED BUFR FORMAT INTO BUFR MESSAGE.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *BUFRENC(IERR)*
C
C     EXTERNALS.
C     ----------
C
C         *CALL* *SETWT(K,IERR)*
C         *CALL* *SEC0(IERR)*
C         *CALL* *SEC1(K,IERR)*
C         *CALL* *SEC2(IERR)*
C         *CALL* *SEC3(K,IERR)*
C         *CALL* *SEC4(IERR)*
C         *CALL* *SEC5(IERR)*
C
C     AUTHOR.
C     -------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
C
C
C     MODIFICATIONS.
C     --------------
C
C          R.CINTRA
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'compoin.h'
      INCLUDE 'comwork.h'
C
C     ------------------------------------------------------------------
C*          1.   SET UP *BUFR* MESSAGE.
C                ----------------------
 100  CONTINUE
C
      IF( IERR.NE.0 ) RETURN
C
C           1.1 SET WORKING TABLES AND BUFR SECTION DATA.
C               -----------------------------------------
 110  CONTINUE
C
      CALL SETWT( K,IERR )
      CALL SEC0 ( IERR )
      CALL SEC1 ( IERR )
      CALL SEC2 ( IERR )
      CALL SEC3 ( K,IERR )
      CALL SEC4 ( IERR )
      CALL SEC5 ( IERR )
      CALL PUTBUFR( K,IERR )
C     ------------------------------------------------------------------
C
      RETURN
      END
      
      SUBROUTINE OCTNUM(KWPTB,KBPTB)
C
C**** *OCTNUM*
C
C
C     PURPOSE.
C     --------
C             CALCULATE NUMBER OF OCTETS FROM BIT POSITION DEFINED BY
C     KWPT,KBPT  AND KWPTB,KBPTB; NUMBER OF OCTETS MUST BE EVEN. IF IT IS
C     NEEDED PADING WITH 0 BIT PERFORMS. NUMBER OF OCTETS IS WRITTEN AT
C     BEGINIG OF THE SECTION.
C
C**   INTERFACE.
C     ----------
C
C          *CALL* *OCTNUM(KWPTB,KBPTB)*
C.
C
C     EXTERNALS.
C     ----------
C
C     *CALL* *PACK(KBPW,KD,KS,KWPT,KBPT,KSI)*
C
C            *KBPW*  - NUMBER OF BITS IN COMPUTER WORD.
C            *KD*    - DESTINATION ARRAY.
C            *KS*    - SOURCE
C            *KWPT*  - POINTER TO WORD IN KD ARRAY.
C            *KBPT*  - POINTER TO BIT IN THE KD(KWPT)
C            *KSI*   - NUMBER OF BITS ACCUPIED BY KS.
C
C      *CALL* *SBYTE(KD,KS,KSKIP,KSIZE)
C
C             *KD*    - DESTINATION
C             *KS*    - SOURCE
C             *KSKIP* - NUMBER OF BITS TO BE SKIPPED
C             *KSIZE* - BIT LENGTH
C
C     AUTHOR.
C     -------
C
C          M. D. DRAGOSAVAC    *ECMWF*       07/10/87.
C
C
C     MODIFICATIONS.
C     --------------
C
C          R.CINTRA.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
C
      INCLUDE 'parameter.h'
      INCLUDE 'compoin.h'
C     ------------------------------------------------------------------
C*          1.    CALCULATE NUMBER OF OCTETS.
C                 ---------------------------
 100  CONTINUE
C
      IB   =(NWPT-1) * NBPW + NBPT
      IBB  =(KWPTB-1)* NBPW + KBPTB
C
      IDIFB= IB - IBB
C
      NOCT = IDIFB/8
      IBDW = IDIFB - NOCT*8
C
      IF(IBDW .NE.0)THEN
                       NOCT=NOCT+1
                       IBDW=8-IBDW
                       CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,IBDW )
                    END IF
C
C     ------------------------------------------------------------------
C*          2.  CHECK IF THERE ARE EVEN NUMBER OF OCTETS IN BLOCK.
C               --------------------------------------------------
 200  CONTINUE
C
      IF(MOD(NOCT,2).NE.0) THEN
          IBDW = 8
          CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,IBDW )
          NOCT = NOCT+1
      END IF
C     ------------------------------------------------------------------
C*          3.  WRITE NUMBER OF OCTETS AT BEGINING OF BLOCK.
C               --------------------------------------------
 300  CONTINUE
C
      IBDW  = 24
      CALL SBYTE(MBUF(KWPTB),NOCT,KBPTB,IBDW)
C
      RETURN
      END
      
      SUBROUTINE PACK(KBPW,KD,KS,KWPT,KBPT,KSI)
C
C**** *PACK*
C
C
C     PURPOSE.
C     --------
C            PURPOSE OF THIS ROUTINE IS TO PACK VALUE *KS* IN
C         *KSI* BITS, STARTED AT WORD KWPT OF ARRAY *KD* AFTER
C         SKIPPING NBPT BITS.  AT THE END
C         POINTERS *NWPT* AND *NBPT* ARE ADJUSTED.
C
C**   INTERFACE.
C     ----------
C
C     *CALL* *PACK(KBPW,KD,KS,KWPT,KBPT,KSI)*
C
C            *KD*    - DESTINATION ARRAY.
C            *KS*    - SOURCE
C            *KSI*   - NUMBER OF BITS ACCUPIED BY KS.
C
C     EXTERNALS.
C     ----------
C
C
C            *CALL SBYTE(KD,KS,KBPT,KSI)*
C
C            *KD*    - DESTINATION ARRAY.
C            *KS*    - SOURCE
C            *KBPT*  - POINTER TO BIT IN THE KD(KWPT)
C            *KSI*   - NUMBER OF BITS ACCUPIED BY KS.
C
C
C     AUTHOR.
C     -------
C
C          M. D. DRAGOSAVAC    *ECMWF*       09/06/86.
C
C
C     MODIFICATIONS.
C     --------------
C
C          R.CINTRA
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
C
      DIMENSION KD(*)
C
C     ------------------------------------------------------------------
C*          1.   SET UP BIT PATTERN.
C                -------------------
C
 100  CONTINUE
C
      CALL SBYTE(KD,KS,KBPT,KSI)
C
C     ------------------------------------------------------------------
C*          1.1  UPDATE WORD AND BIT POINTERS.
C                -----------------------------
 110  CONTINUE
C
      KBPT = KBPT + KSI
C
      IF(KBPT.GE.KBPW) THEN
                          KW  = KBPT/ KBPW
                          KBPT= KBPT - KW * KBPW
                          KWPT= KWPT +KW
                       END IF
C
      RETURN
      END
      
      SUBROUTINE SEC0( IERR )
C
C**** *SEC0*
C
C
C     PURPOSE.
C     --------
C         PURPOSE OF THIS ROUTINE IS TO SET UP SECTION 0 OF *BUFR
C         MESSAGE.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *SEC0(IERR)*
C
C     EXTERNALS.
C     ----------
C
C         *CALL* *PACK(KBPW,KD,KS,KWPT,KBPT,KSI)*
C
C            *KBPW*  - NUMBER OF BITS IN COMPUTER WORD.
C            *KD*    - DESTINATION ARRAY.
C            *KS*    - SOURCE
C            *KWPT*  - POINTER TO WORD IN KD ARRAY.
C            *KBPT*  - POINTER TO BIT IN THE KD(KWPT)
C            *KSI*   - NUMBER OF BITS ACCUPIED BY KS.
C
C     AUTHOR.
C     -------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
C
C
C     MODIFICATIONS.
C     --------------
C
C          M. Dragosavac 13/11/1991  : change to Bufr Edition 2
c	   Rosangela Cintra
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
C
C
      INCLUDE 'parameter.h'
      INCLUDE 'compoin.h'
C     ------------------------------------------------------------------
C
C*          1.   SET UP *SECTION 0 ( INDICATOR SECTION )
C                --- --  ------- -   --------- -------
 100  CONTINUE
C
      IF( IERR.NE.0 ) RETURN
C
C*          1.1  IT IS FOUR OCTETS LONG CHARACTER CODED ACCORDING TO THE
C                -------------------------------------------------------
C                *INTERNATIONAL *TELEGRAPHIC *ALPHABET *NO. 5 AS *BUFR*.
C                 -------------------------------------------------------
 110  CONTINUE
C
      NWPT= 2
      NBPT= 0
C
C     B IS CCITT.5 DECIMAL 66
C     U IS CCITT.5 DECIMAL 85
C     F IS CCITT.5 DECIMAL 70
C     R IS CCITT.5 DECIMAL 82
C
      CALL PACK(NBPW,MBUF(NWPT),66,NWPT,NBPT,8)
      CALL PACK(NBPW,MBUF(NWPT),85,NWPT,NBPT,8)
      CALL PACK(NBPW,MBUF(NWPT),70,NWPT,NBPT,8)
      CALL PACK(NBPW,MBUF(NWPT),82,NWPT,NBPT,8)
C
C            Bufr Edition 2
C
      CALL PACK(NBPW,MBUF(NWPT), 0,NWPT,NBPT,24)
      CALL PACK(NBPW,MBUF(NWPT), 2,NWPT,NBPT,8)
C
      RETURN
      END
      
      SUBROUTINE SEC1(IERR)
C
C**** *SEC1*
C
C
C     PURPOSE.
C     --------
C         PURPOSE OF THIS ROUTINE IS TO SET UP SECTION 1 OF *BUFR
C         MESSAGE.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *SEC1(IERR)*
C
C
C     EXTERNALS.
C     ----------
C
C         *CALL* *PACK(KBPW,KD,KS,KWPT,KBPT,KSI)*
C
C            *KBPW*  - NUMBER OF BITS IN COMPUTER WORD.
C            *KD*    - DESTINATION ARRAY.
C            *KS*    - SOURCE
C            *KWPT*  - POINTER TO WORD IN KD ARRAY.
C            *KBPT*  - POINTER TO BIT IN THE KD(KWPT)
C            *KSI*   - NUMBER OF BITS ACCUPIED BY KS.
C
C         *CALL* *OCTNUM(KWPTB,KBPTB)*
C
C            *KWPTB* - POINTER TO WORD AT BEGINING OF SECTION.
C            *KBPTB* - POINTER TO BIT ISIDE THE WORD.
C
C     AUTHOR.
C     -------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
C
C
C     MODIFICATIONS.
C     --------------
C
C          M. Dragosavac 14/11/1991  Bufr Edition 2 introduced.
c	   Rosangela Cintra  1999
c          Rosangela Cintra  11/01/2000   year of century
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
C
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'compoin.h'
      INCLUDE 'comwt.h'
      INCLUDE 'comkey.h'
C     ------------------------------------------------------------------
C
C*          1.   SET UP *SECTION 1 ( IDENTIFICATION SECTION).
C                --------------------------------------------
 100  CONTINUE
C
      IF( IERR.NE.0) RETURN
C     ------------------------------------------------------------------
C*          2.   KEEP POINTERS TO THE BEGINING OF THE SECTION.
C                ---------------------------------------------
 200  CONTINUE
C
      IWPTB = NWPT
      IBPTB = NBPT
C
C     ------------------------------------------------------------------
C*          3.   SET UP LENGTH OF SECTION (OCTET 1-3 ) TO ZERO.
C                ----------------------------------------------
 300  CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,24)
C
C     ------------------------------------------------------------------
C*          4.   BUFR master table (zero if WMO  FM 94-IX Ext used)
C                ---------------------------------------------------
 400  CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,8)
C
C     ------------------------------------------------------------------
C*          5.   SET UP ORIGINATING CENTRE.
C                --------------------------
 500  CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),46,NWPT,NBPT,16)
C
C     ------------------------------------------------------------------
C*          6.   SET UP UPDATE SEQUENCE NUMBER.
C                ------------------------------
 600  CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT,8)
C
C
C     ------------------------------------------------------------------
C*          7.   SET UP PRESENCE OF SECTION 2.
C                -----------------------------
 160  CONTINUE
C
      IPS2=0
      IF(OPS2) IPS2=128
      CALL PACK(NBPW,MBUF(NWPT),IPS2,NWPT,NBPT,8)
C
C     ------------------------------------------------------------------
C*          1.7  SET UP BUFR  MESSAGE TYPE.
C                --------------------------
 700  CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),NBUFTYPE,NWPT,NBPT,8)
C
C     ------------------------------------------------------------------
C*          8.   SET UP BUFR MESSAGE SUB-TYPE.
C                -----------------------------
 800  CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),NSBTYPE,NWPT,NBPT,8)
C
C     ------------------------------------------------------------------
C*          9.   VERSION NUMBER OF MASTER TABLE USED (CURRENTLY 2).
C                --------------------------------------------------
 900  CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),2,NWPT,NBPT,8)
C
C*          9.1  VERSION NUMBER OF LOCAL TABLES USED.
C                ------------------------------------
 910  CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT,8)
C
C     ------------------------------------------------------------------
C*          10.  SET UP YEAR OF CENTURY.
C                -----------------------
 1000 CONTINUE
C
      iyear=values(4,1)
      icen = (iyear * .01)
      IYEAR=iYEAR - (icen * 100.)
      if (iyear .eq. 0) iyear=100
      CALL PACK(NBPW,MBUF(NWPT),IYEAR,NWPT,NBPT,8)
C
C     ------------------------------------------------------------------
C*          11.  SET UP MONTH.
C                -------------
 1100 CONTINUE
C
      IMONTH=VALUES(5,1)
      CALL PACK(NBPW,MBUF(NWPT),IMONTH,NWPT,NBPT,8)
C
C     ------------------------------------------------------------------
C*          12.  SET UP DAY.
C                -----------
 1200 CONTINUE
C
      IDAY=VALUES(6,1)
      CALL PACK(NBPW,MBUF(NWPT),IDAY,NWPT,NBPT,8)
C
C     ------------------------------------------------------------------
C*          13.  SET UP HOUR.
C                -------------
 1300 CONTINUE
C
      IHOUR=VALUES(7,1)
      CALL PACK(NBPW,MBUF(NWPT),IHOUR,NWPT,NBPT,8)
C
C     ------------------------------------------------------------------
C*          14.  SET UP MINUTE.
C                -------------
 1400 CONTINUE
C
      IMIN=VALUES(8,1)
      CALL PACK(NBPW,MBUF(NWPT),IMIN,NWPT,NBPT,8)
C
C     ------------------------------------------------------------------
C*          15.  SET UP LENGTH OF THE SECTION 1.
C                --------------------------------
 1500 CONTINUE
C
      CALL OCTNUM(IWPTB,IBPTB)
C
C     ------------------------------------------------------------------
C
 1600 CONTINUE
C
      RETURN
      END
      
      SUBROUTINE SEC2( IERR )
C
C**** *SEC2*
C
C
C     PURPOSE.
C     --------
C         PURPOSE OF THIS ROUTINE IS TO SET UP SECTION 2 OF *BUFR
C         MESSAGE.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *SEC2(IERR)*
C
C     EXTERNALS.
C     ----------
C
C         *CALL* *PACK(KBPW,KD,KS,KWPT,KBPT,KSI)*
C
C            *KBPW*  - NUMBER OF BITS IN COMPUTER WORD.
C            *KD*    - DESTINATION ARRAY.
C            *KS*    - SOURCE
C            *KWPT*  - POINTER TO WORD IN KD ARRAY.
C            *KBPT*  - POINTER TO BIT IN THE KD(KWPT)
C            *KSI*   - NUMBER OF BITS ACCUPIED BY KS.
C
C         *CALL* *OCTNUM(KWPTB,KBPTB)*
C
C            *KWPTB* - POINTER TO WORD AT BEGINING OF SECTION.
C            *KBPTB* - POINTER TO BIT ISIDE THE WORD.
C
C     AUTHOR.
C     -------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
C
C
C     MODIFICATIONS.
C     --------------
C
C          R. CINTRA
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
C
C
      INCLUDE 'parameter.h'
      INCLUDE 'compoin.h'
C     ------------------------------------------------------------------
C
C*          1.   SET UP *SECTION 2 ( OPTIONA SECTION).
C                -------------------------------------
 100  CONTINUE
C
      IF( IERR.NE.0 ) RETURN
      IF(.NOT. OPS2 ) RETURN
C     ------------------------------------------------------------------
C*          1.1  KEEP POINTERS TO THE BEGINING OF THE SECTION.
C                ---- -------- -- --- -------- -- --- -------
 110  CONTINUE
C
      IWPTB = NWPT
      IBPTB = NBPT
C     ------------------------------------------------------------------
C*          1.2  SET UP LENGTH OF SECTION (OCTET 1-3 ) TO ZERO.
C                ----------------------------------------------
 120  CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,24)
C
C     ------------------------------------------------------------------
C*          1.3  SET UP RESERVED BYTE  TO ZERO.
C                ------------------------------
 130  CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,8)
C
C     ------------------------------------------------------------------
C*          1.4  SET UP RDB KEY (48 BYTES).
C
 140  CONTINUE
C 
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,32)
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,32)
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,32)
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,32)
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,32)
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,32)
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,32)
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,32)
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,32)
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,32)
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,32)
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,32)
C
C*          1.5  SET UP LENGTH OF THE SECTION 2.
C                ------------------------------
 150  CONTINUE
C
      CALL OCTNUM(IWPTB,IBPTB)
C
C     ------------------------------------------------------------------
 200  CONTINUE
C
      RETURN
      END
      
      SUBROUTINE SEC3(K,IERR )
C
C**** *SEC3*
C
C
C     PURPOSE.
C     --------
C         PURPOSE OF THIS ROUTINE IS TO SET UP SECTION 3 OF *BUFR
C         MESSAGE.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *SEC3(K,IERR)*
C
C     EXTERNALS.
C     ----------
C
C         *CALL* *PACK(KBPW,KD,KS,KWPT,KBPT,KSI)*
C
C            *KBPW*  - NUMBER OF BITS IN COMPUTER WORD.
C            *KD*    - DESTINATION ARRAY.
C            *KS*    - SOURCE
C            *KWPT*  - POINTER TO WORD IN KD ARRAY.
C            *KBPT*  - POINTER TO BIT IN THE KD(KWPT)
C            *KSI*   - NUMBER OF BITS ACCUPIED BY KS.
C
C         *CALL* *OCTNUM(KWPTB,KBPTB)*
C
C            *KWPTB* - POINTER TO WORD AT BEGINING OF SECTION.
C            *KBPTB* - POINTER TO BIT ISIDE THE WORD.
C
C
C     AUTHOR.
C     -------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
C
C
C     MODIFICATIONS.
C     --------------
C
C          R.CINTRA
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
C
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'compoin.h'
      INCLUDE 'comwt.h'
C     ------------------------------------------------------------------
C
C*          1.   SET UP *SECTION 3 ( DATA DESCRIPTION SECTION ).
C                -----------------------------------------------
 100  CONTINUE
C
      IF( IERR.NE.0 ) RETURN
C
C     ------------------------------------------------------------------
C*          1.1  KEEP POINTERS TO THE BEGINING OF THE SECTION.
C                ---------------------------------------------
 110  CONTINUE
C
      IWPTB = NWPT
      IBPTB = NBPT
C     ------------------------------------------------------------------
C*          1.2  SET UP LENGTH OF SECTION (OCTET 1-3 ) TO ZERO.
C                ----------------------------------------------
 120  CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,24)
C
C     ------------------------------------------------------------------
C*          1.3  SET UP RESERVED BYTE  TO ZERO.
C                ------------------------------
 130  CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,8)
C
C     ------------------------------------------------------------------
C*          1.4  SET UP NUMBER OF DATA SUB-SETS.
C                -------------------------------
 140  CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),NS,NWPT,NBPT,16)
C
C     ------------------------------------------------------------------
C*          1.5  SET UP INFORMATION ABOUT TYPE OF DATA AND COMPRESSION.
C                ------------------------------------------------------
 150  CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),128,NWPT,NBPT,8)
C
C     ------------------------------------------------------------------
C*          1.6  SET UP COLLECTION OF DESCRIPTORS WHICH DEFINE DATA.
C                --------------------------------------------------
 160  CONTINUE
C
C     METAR- BASIC REPORT
C
      IF(K.EQ.1) THEN
C
         IF(KDEC(4).EQ.16.OR.KDEC(4).EQ.14) THEN
               CALL PACK(NBPW,MBUF(NWPT),3,NWPT,NBPT, 2)
               CALL PACK(NBPW,MBUF(NWPT),7,NWPT,NBPT, 6)
               CALL PACK(NBPW,MBUF(NWPT),9,NWPT,NBPT, 8)
C
C
C              CHECK IF Q/C PERFORMED.
C
               IBIT1=0
               DO 161 I=M+1,M+M
               IF(VALUES(I,NSUB).NE.999999.) IBIT1=IBIT1+1
 161           CONTINUE
C
               IF(IBIT1.EQ.0) GO TO 170
               
               MQ=27
               CALL PACK(NBPW,MBUF(NWPT),2,NWPT,NBPT, 2)
               CALL PACK(NBPW,MBUF(NWPT),22,NWPT,NBPT, 6)
               CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 8)
C
               CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT, 2)
               CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT, 6)
               CALL PACK(NBPW,MBUF(NWPT),M,NWPT,NBPT, 8)
C
               CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 2)
               CALL PACK(NBPW,MBUF(NWPT),31,NWPT,NBPT, 6)
               CALL PACK(NBPW,MBUF(NWPT),31,NWPT,NBPT, 8)
C
               CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 2)
               CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT, 6)
               CALL PACK(NBPW,MBUF(NWPT),31,NWPT,NBPT, 8)
C
               CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 2)
               CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT, 6)
               CALL PACK(NBPW,MBUF(NWPT),201,NWPT,NBPT, 8)
C
               CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT, 2)
               CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT, 6)
               CALL PACK(NBPW,MBUF(NWPT),IBIT1,NWPT,NBPT, 8)
C
               CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 2)
               CALL PACK(NBPW,MBUF(NWPT),33,NWPT,NBPT, 6)
               CALL PACK(NBPW,MBUF(NWPT),7,NWPT,NBPT, 8)
                
            END IF
C
      END IF
C
C     ------------------------------------------------------------------
C*          1.7  SET UP LENGTH OF THE SECTION 3.
C                -------------------------------
 170  CONTINUE
C
      CALL OCTNUM(IWPTB,IBPTB)
C
C     ------------------------------------------------------------------
 200  CONTINUE
C
      RETURN
      END
      
      SUBROUTINE SEC4( IERR )
C
C**** *SEC4*
C
C
C     PURPOSE.
C     --------
C         PURPOSE OF THIS ROUTINE IS TO SET UP SECTION 4 OF *BUFR
C         MESSAGE.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *SEC4(IERR)*
C
C     EXTERNALS.
C     ----------
C
C         *CALL* *PACK(KBPW,KD,KS,KWPT,KBPT,KSI)*
C
C            *KBPW*  - NUMBER OF BITS IN COMPUTER WORD.
C            *KD*    - DESTINATION ARRAY.
C            *KS*    - SOURCE
C            *KWPT*  - POINTER TO WORD IN KD ARRAY.
C            *KBPT*  - POINTER TO BIT IN THE KD(KWPT)
C            *KSI*   - NUMBER OF BITS ACCUPIED BY KS.
C
C         *CALL* *OCTNUM(KWPTB,KBPTB)*
C
C            *KWPTB* - POINTER TO WORD AT BEGINING OF SECTION.
C            *KBPTB* - POINTER TO BIT ISIDE THE WORD.
C
C         *CALL* *GBYTE(KS,KD,KSKI,KSI)
C
C            *KS*    - SOURCE
C            *KD*    - DESTINATION
C            *KSKI*  - NUMBER OF BITS TO BE SKIPPED
C            *KSI*   - NUMBER OF BITS TO BE EXTRACTED
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       15/08/88.
C
C
C     MODIFICATIONS.
C     --------------
C
C          R.CINTRA
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'compoin.h'
      INCLUDE 'comwt.h'
C
      CHARACTER*24 CUNIT,YUNIT
      CHARACTER*9 CVAL,YVAL
C
      INCLUDE 'comwtc.h'
C
C     ------------------------------------------------------------------
C
C*          1.   SET UP *SECTION 4 ( DATA SECTION).
C                ----------------------------------
 100  CONTINUE
C
      IF( IERR.NE.0 ) RETURN
C     ------------------------------------------------------------------
C*          1.1  KEEP POINTERS TO THE BEGINING OF THE SECTION.
C                ---------------------------------------------
 110  CONTINUE
C
      IWPTB = NWPT
      IBPTB = NBPT
C
C     ------------------------------------------------------------------
C*          1.2  SET UP LENGTH OF SECTION (OCTET 1-3 ) TO ZERO.
C                ----------------------------------------------
 120  CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,24)
C
C     ------------------------------------------------------------------
C*          1.3  SET UP RESERVED BYTE  TO ZERO.
C                ------------------------------
 130  CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,8)
C
C     ------------------------------------------------------------------
C*          2.   SET UP BINARY DATA AS DEFINED BY SEQUENCE DESCRIPTOR.
C                ------------------------------------------------
 200  CONTINUE
C
      DO 201 I=1,Ns
      DO 202 J=1,M
C
      IREF  =IWTRV(J)
      ISCALE=IWTS (J)
      IBDW  =IWTDW(J)
      YUNIT =CUNIT(J)
C
      VAL=VALUES(J,I)
c      print*,j,iwtr(j),val
C
      IF(YUNIT.EQ.'CCITTIA5') THEN
         IST=NINT(VAL)/1000
         NCHAR=NINT(VAL)-IST*1000
         YVAL=CVAL(IST)
         DO 203 II=1,NCHAR
         IPACK=ICHAR(YVAL(II:II))
         CALL PACK(NBPW,MBUF(NWPT),IPACK,NWPT,NBPT,8)
 203     CONTINUE
         GO TO 202
      END IF
C
      IF(VAL.EQ.999999.) THEN
         CALL PACK(NBPW,MBUF(NWPT),MASKS(IBDW),NWPT,NBPT,IBDW)
      ELSE
         IF(ISCALE.LT.0) THEN
            ISCALE=IABS(ISCALE)
            IPACK=NINT(VAL/10.**ISCALE) - IREF
         ELSE
            IPACK=NINT(VAL*10.**ISCALE) - IREF
         END IF
c         kbpt= nbpt
c         ksi = ibdw
c         kwpt = nwpt 
         CALL PACK(NBPW,MBUF(NWPT),IPACK,NWPT,NBPT,IBDW)
                  
c         call unpack(nbpw,MBUF(kWPT),kpack,kWPT,kBPT,ksi,ierr)
c         if (ierr .eq. 0) print*,'unpack',iwtr(j),j
c         kpack = kpack + iref
c         upack = (kpack/10.**iscale)
c         print*,'val',upack
      END IF
         
C
 202  CONTINUE

      IF(M.LT.MQ) THEN
C
        DO 210 J=M+1,MQ      
C
        IREV  =IWTR (J)
        IREF  =IWTRV(J)
        ISCALE=IWTS (J)
        IBDW  =IWTDW(J)
        YUNIT =CUNIT(J)
C
        IF(IREV.EQ.031031) THEN
C 
C          SET BIT FLAG
C
           IBIT1=0
C
           DO 215 JI=M+1,M+M
C
           IPACK=1
           IF(VALUES(JI,I).NE.999999.) IPACK=0
           CALL PACK(NBPW,MBUF(NWPT),IPACK,NWPT,NBPT,1)
C
 215       CONTINUE
C           
        END IF
C
c         kbpt= nbpt
c         ksi = ibdw
c         kwpt = nwpt
        IF(IREV.EQ.001031) THEN
           VAL=46.
           IF(VAL.EQ.999999.) THEN
              CALL PACK(NBPW,MBUF(NWPT),MASKS(IBDW),NWPT,NBPT,IBDW)
           ELSE
              IF(ISCALE.LT.0) THEN
                 ISCALE=IABS(ISCALE)
                 IPACK=NINT(VAL/10**ISCALE) - IREF
              ELSE
                 IPACK=NINT(VAL*10**ISCALE) - IREF
              END IF
              CALL PACK(NBPW,MBUF(NWPT),IPACK,NWPT,NBPT,IBDW)
           END IF
        END IF 
C
        IF(IREV.EQ.001032) THEN
           VAL=999999.
           IF(VAL.EQ.999999.) THEN
              CALL PACK(NBPW,MBUF(NWPT),MASKS(IBDW),NWPT,NBPT,IBDW)
           ELSE
              IF(ISCALE.LT.0) THEN
                 ISCALE=IABS(ISCALE)
                 IPACK=NINT(VAL/10**ISCALE) - IREF
              ELSE
                 IPACK=NINT(VAL*10**ISCALE) - IREF
              END IF
              CALL PACK(NBPW,MBUF(NWPT),IPACK,NWPT,NBPT,IBDW)
           END IF
        END IF 
C
        IF(IREV.EQ.001201) THEN
           VAL=1.
           IF(VAL.EQ.999999.) THEN
              CALL PACK(NBPW,MBUF(NWPT),MASKS(IBDW),NWPT,NBPT,IBDW)
           ELSE
              IF(ISCALE.LT.0) THEN
                 ISCALE=IABS(ISCALE)
                 IPACK=NINT(VAL/10**ISCALE) - IREF
              ELSE
                 IPACK=NINT(VAL*10**ISCALE) - IREF
              END IF
              CALL PACK(NBPW,MBUF(NWPT),IPACK,NWPT,NBPT,IBDW)
           END IF
        END IF         
C
        IF(IREV.EQ.033007) THEN
           DO 216 JI=M+1,M+M
           VAL=VALUES(JI,I)
           IF(VAL.EQ.999999.) GO TO 216
C
           IF(ISCALE.LT.0) THEN
              ISCALE=IABS(ISCALE)
              IPACK=NINT(VAL/10**ISCALE) - IREF
           ELSE
              IPACK=NINT(VAL*10**ISCALE) - IREF
           END IF
C
           CALL PACK(NBPW,MBUF(NWPT),IPACK,NWPT,NBPT,IBDW)
           
c            call unpack(nbpw,MBUF(kWPT),kpack,kWPT,kBPT,ksi,ierr)
c            if (ierr .eq. 0) print*,'unpack',irev
c             kpack = kpack + iref
c             upack = (kpack/10.**iscale)
c             print*,'val1',upack
c             kbpt= nbpt
c             ksi = ibdw
c             kwpt = nwpt
C
 216       CONTINUE
C
c        else
c         call unpack(nbpw,MBUF(kWPT),kpack,kWPT,kBPT,ksi,ierr)
c         if (ierr .eq. 0) print*,'unpack',irev
c         kpack = kpack + iref
c         upack = (kpack/10.**iscale)
c         print*,'val1',upack 
        END IF
C
 210    CONTINUE
C
      END IF
C
 201  CONTINUE
C
C     ------------------------------------------------------------------
C*         12.   SET UP LENGTH OF THE SECTION 4.
C                -------------------------------
 1200 CONTINUE
C
      CALL OCTNUM(IWPTB,IBPTB)
C
C     ------------------------------------------------------------------
 1300 CONTINUE
C
      RETURN
      END
      
      SUBROUTINE SEC5( IERR )
C
C**** *SEC5*
C
C
C     PURPOSE.
C     --------
C         PURPOSE OF THIS ROUTINE IS TO SET UP SECTION 5 OF *BUFR
C         MESSAGE.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *SEC5(IERR)*
C
C
C     EXTERNALS.
C     ----------
C
C         *CALL* *PACK(KBPW,KD,KS,KWPT,KBPT,KSI)*
C
C            *KBPW*  - NUMBER OF BITS IN COMPUTER WORD.
C            *KD*    - DESTINATION ARRAY.
C            *KS*    - SOURCE
C            *KWPT*  - POINTER TO WORD IN KD ARRAY.
C            *KBPT*  - POINTER TO BIT IN THE KD(KWPT)
C            *KSI*   - NUMBER OF BITS ACCUPIED BY KS.
C
C
C     AUTHOR.
C     -------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
C
C
C     MODIFICATIONS.
C     --------------
C
C          R.CINTRA
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
C
C
      INCLUDE 'parameter.h'
      INCLUDE 'compoin.h'
C
C     ------------------------------------------------------------------
C
C*          1.   SET UP *SECTION 5 ( END SECTION ).
C                ----------------------------------
 100  CONTINUE
C
      IF( IERR.NE.0 ) RETURN
C
C*          1.1  IT IS FOUR OCTETS LONG CHARACTER CODED ACCORDING TO THE
C                -------------------------------------------------------
C                *INTERNATIONAL *TELEGRAPHIC *ALPHABET *NO. 5 AS *BUFR*.
C                 ------------------------------------------------------
 110  CONTINUE
C
C
C     7 IS CCITT.5 DECIMAL 55
C
      CALL PACK(NBPW,MBUF(NWPT),55,NWPT,NBPT,8)
      CALL PACK(NBPW,MBUF(NWPT),55,NWPT,NBPT,8)
      CALL PACK(NBPW,MBUF(NWPT),55,NWPT,NBPT,8)
      CALL PACK(NBPW,MBUF(NWPT),55,NWPT,NBPT,8)
C
C                                                                       
C*          1.3  SET TOTAL LENGTH OF BUFR MESSAGE.
C                ---------------------------------
 130  CONTINUE
C
      IBYTES=(NWPT-2)*NBPW/8+NBPT/8
c      print*,ibytes
C
C*          1.4  SET TOTAL LENGTH OF BUFR MESSAGE IN SECTION 0.
C                ----------------------------------------------
 140  CONTINUE
C
C        FOR BUFR EDITION 2 LENGTH OF MESSAGE STARTS AT 5 TH BYTE.
C
      IWPT= 32/NBPW + 2
      IBPT= 32 - (IWPT-1)* NBPW
      ibpt = 0
C
      CALL PACK(NBPW,MBUF(IWPT),IBYTES,IWPT,IBPT,24)
C
      RETURN
      END
   
      SUBROUTINE PUTBUFR(K,IERR )
C
C**** *PUTBUFR*
C
C
C     PURPOSE.
C     --------
C         PUT BUFR MESSAGE INTO REPORT DATA BASE.
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *PUTBUFR(IERR)*
C
C     AUTHOR.
C     -------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/08/88.
C
C
C
C     MODIFICATIONS.
C     --------------
C
C         R.CINTRA
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'compoin.h'
      INCLUDE 'comwt.h'
      INCLUDE 'comkey.h'
      INCLUDE 'comkeyc.h' 
      INCLUDE 'comrec.h'
      include 'comdate.h'
C
      common /recwriten/ irecswriten
      common /repetida/ irepetida
      common /comicao/ icao
c
      CHARACTER*15000 YOUT
      CHARACTER*9  CIDENT
      character*4  icao
      CHARACTER*48 CKEY
      CHARACTER*32 YKEY
      CHARACTER*14 YTIME
      integer iyyy,imo,idd,iutc,ihh,imm,iss,icc
C
      character*48 records_writen(6000)
      character*46 ckey_aux
      equivalence(ckey_aux,ckey(3:3))
c
      DIMENSION IKEY(12),ikey1(22)
C
      EQUIVALENCE (IKEY(1),YKEY,CKEY)
      EQUIVALENCE (MBUF(1),YOUT)

C     ------------------------------------------------------------------
C*          1. DEFINE RDB FILE NAME AND OPEN RDB FILE.
C                -------------------------------------
 100  CONTINUE
C
      IRET=0
c      icen = nyear*.01        
c      NY=NYEAR - (icen *100) 
c      print*,ny,nmonth,nday,nhour,nminute,nsecond
c
c      WRITE(YTIME,'(6I2.2)',IOSTAT=IOS,ERR=101)
c     1       NY,NMONTH,NDAY,NHOUR,NMINUTE,NSECOND
      WRITE(YTIME,'(i4.4,5I2.2)',IOSTAT=IOS,ERR=101)
     1       NY,NM,ND,NH,NMIN,NSEC
C
      CTABNAME='metar_'//YTIME(1:6)
      GO TO 102
C
 101  CONTINUE
C
      PRINT*,'BAD DATE OR TIME , OBSERVATION IS SKIPPED. IOSTAT=',IOS
      RETURN
C
 102  CONTINUE
C
C*          2.  DEFINE RDB KEY AND HOUSEHEEPING INFORMATION.
C               --------------------------------------------
 200  CONTINUE
C
      IW=1
      IBT=0
C
C*          2.1 DEFINE RDB KEY.
C               ---------------
 210  CONTINUE
C 
      CALL PACK(32,IKEY(IW),NTYPE,IW,IBT,8)      
      CALL PACK(32,IKEY(IW),NSBTYPE,IW,IBT,8)     
      CALL PACK(32,IKEY(IW),NYEAR,IW,IBT,12)     
      CALL PACK(32,IKEY(IW),NMONTH,IW,IBT,4)      
      CALL PACK(32,IKEY(IW),NDAY,IW,IBT,6)      
      CALL PACK(32,IKEY(IW),NHOUR,IW,IBT,5)      
      CALL PACK(32,IKEY(IW),NMINUTE,IW,IBT,6)      
      CALL PACK(32,IKEY(IW),NSECOND,IW,IBT,6)     
      CALL PACK(32,IKEY(IW),0,IW,IBT,1)     
      CALL PACK(32,IKEY(IW),NLON1,IW,IBT,26)   
      CALL PACK(32,IKEY(IW),0,IW,IBT,6)      
      CALL PACK(32,IKEY(IW),NLAT1,IW,IBT,25)     
      CALL PACK(32,IKEY(IW),0,IW,IBT,7)        
c
c      YKEY(16:24)=CIDENT
c
c     atribuicao do identificador da estacao
c     por assinalamento de alto nivel
c     respeitando a inversao de bytes (little-endian)
c
c      YKEY(13:13)=CIDENT(1:1)
c      YKEY(17:17)=CIDENT(5:5)
c      YKEY(18:18)=CIDENT(4:4)
c      YKEY(19:19)=CIDENT(3:3)
c      YKEY(20:20)=CIDENT(2:2)
c      YKEY(21:24)=' '
c      YKEY(25:32)=' '

c      print*,icao
      YKEY(13:13)=icao(1:1)
      ykey(20:20)=icao(2:2)
      YKEY(19:19)=icao(3:3)
      YKEY(18:18)=icao(4:4)
      ykey(17:17)=' '
      YKEY(21:24)=' '
c      YKEY(25:32)=' '
C
C*          2.2 DEFINE HOUSE KEEPING INFORMATION.      
C               ---------------------------------
 220  CONTINUE
C
      ILENGTH=(NWPT-2)*4+NBPT/8
c      print*,ilength
C
      IF(KDEC(21).EQ.MINDIC) THEN
                                NCORR=0
                             ELSE
                                NCORR=KDEC(21)
                             END IF
C
C     FIND LOWEST QUALITY CONTROL PERCENTAGE. 
C
      IF(M.LT.MQ) THEN
                     RMIN=VALUES(M+1,NSUB)
                     DO 221 I=M+1,M+M
                     IF(VALUES(I,NSUB).LT.RMIN) RMIN=VALUES(I,NSUB)
 221                 CONTINUE
                     NQC=NINT(RMIN)
                  END IF
C      
c       CALL datim(iyyy,imo,idd,iutc,ihh,imm,iss,icc) 
      iyyy=ny
      imo=nm
      idd=nd
      ihh=nh
      imm=nmin
      iss=nsec
c      print*,iyyy,imo,idd      
C
       IW =9
       IBT=0
C
C       SET LENGTH OF RECORD
C
       CALL PACK(32,IKEY(IW),ILENGTH,IW,IBT,16)
       
C
C        SET TIME RECORD WAS LAST WRITTEN TO RDB
C 
      CALL PACK(32,IKEY(IW),IDD,IW,IBT,6)     
      CALL PACK(32,IKEY(IW),IHH,IW,IBT,5)     
      CALL PACK(32,IKEY(IW),IMM,IW,IBT,6)      
      CALL PACK(32,IKEY(IW),ISS,IW,IBT,6)      
      CALL PACK(32,IKEY(IW),0,IW,IBT,1)      
C
C       SET TIME BULLETIN WAS RECEIVED
C
      CALL PACK(32,IKEY(IW),NRDAY,IW,IBT,6)      
      CALL PACK(32,IKEY(IW),NRHOUR,IW,IBT,5)     
      CALL PACK(32,IKEY(IW),NRMIN,IW,IBT,6)    
      CALL PACK(32,IKEY(IW),NRSEC,IW,IBT,6)       
      CALL PACK(32,IKEY(IW),0,IW,IBT,1)      
      CALL PACK(32,IKEY(IW),NCORR,IW,IBT,6)      
      CALL PACK(32,IKEY(IW),NRECR,IW,IBT,1)      
      CALL PACK(32,IKEY(IW),0,IW,IBT,1)      
      CALL PACK(32,IKEY(IW),0,IW,IBT,6)      
      CALL PACK(32,IKEY(IW),0,IW,IBT,1)      
      CALL PACK(32,IKEY(IW),0,IW,IBT,1)      
      CALL PACK(32,IKEY(IW),0,IW,IBT,6)      
      CALL PACK(32,IKEY(IW),0,IW,IBT,1)      
      CALL PACK(32,IKEY(IW),0,IW,IBT,1)      
      CALL PACK(32,IKEY(IW),0,IW,IBT,6)      
      CALL PACK(32,IKEY(IW),0,IW,IBT,1)      
      CALL PACK(32,IKEY(IW),0,IW,IBT,1)      
      CALL PACK(32,IKEY(IW),NQC,IW,IBT,8)     
      CALL PACK(32,IKEY(IW),0,IW,IBT,24)
                
C
C     WRITE RDB KEY INTO SECTION 2 OF BUFR MESSAGE.
C
C     WORD 8 BIT 16
C
c     YOUT(35:82)=CKEY(1:48)
c
c     atribuicao da chave da secao 2
c     por assinalamento de alto nivel
c     respeitando a inversao de bytes (little-endian)
c
      call invbytes(48,ckey)
      yout(34:34) = ckey(1:1)
      yout(33:33) = ckey(2:2)
c
       do 10 i = 1,44
          j = ((i-1)/4 + 10)*4 - MOD((i-1),4)
          yout(j:j) = ckey(i+2:i+2)
 10    continue
c
       yout(84:84) = ckey(47:47)
       yout(83:83) = ckey(48:48)
C
      mbuf(1)=ilength
c      print*,ilength
C
 300  CONTINUE
c         kbpt= 4
c         ksi = 15
c         kwpt = 30
c         IREF  =IWTRV(9)
c         ISCALE=IWTS (9)
c         call unpack(nbpw,MBUF(kWPT),kpack,kWPT,kBPT,ksi,ierr)
c         if (ierr .eq. 0) print*,'unpack',kpack
c         kpack = kpack + iref
c         upack = (kpack/10.**iscale)
c         print*,'val',upack

      call invbytes(ilength+4,yout)
      irecswriten = irecswriten + 1
      do 11 i=1,irecswriten
         if(records_writen(i)(1:32).eq.ckey(1:32)) then
           irecswriten = irecswriten - 1
	   irepetida = irepetida + 1
           go to 400
         end if
 11   continue
      
      records_writen(irecswriten)(1:48) = ckey
      WRITE(99,'(a)')YOUT(5:ilength+4)
      
C     -----------------------------------------------------------------
 400  continue
C
      RETURN
      END
      
      SUBROUTINE SETWT(K,IERR)
C
C**** *SETWT*
C
C
C     PURPOSE.
C     --------
C         SETS UP WORKING TABLE B INFORMATION.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *SETWT(K,IERR)*
C
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
C
C
C     MODIFICATIONS.
C     --------------
C
C          R. CINTRA
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'comwt.h'
      INCLUDE 'comwtc.h'
C
      COMMON /BCOMTAB/ NTABBTR(Jp2),NTABBS (Jp2),NTABBRV(Jp2),
     1                NTABBDW(Jp2),NTABDTR(Jp2),NTABDST(Jp2),
     2                NTABDL (Jp2),NTABDSQ(Jp2*20),NTABP(64,255)

      COMMON /BCOMTABC / CTABBEN(jp2),CTABBU (jp2)
c
      CHARACTER    CTABBEN*64,CTABBU*24,CTEXT*64
                 
C
      DIMENSION ITBTRL(27)
     1,         ITBTRA(27)
C
      DATA ITBTRL/001001,001002,002001,004001,004002
     1,           004003,004004,004005,005002,006002
     2,           007001,010051,011011,011012,012004
     3,           012006,020001,020003,020010,008002
     4,           020011,020012,020013,031031,001031
     5,           001201,033007/


C
C     ------------------------------------------------------------------
C*          1.   SET UP WORKING TABLES FOR METAR DATA.
C                ----------------------------------------------
 100  CONTINUE
C
      IF(IERR.NE.0) RETURN
C
C     SET UP BASIC SURFACE REPORT.
C
      IF(K.EQ.1) THEN
C
         IF(KDEC(4).EQ.16.OR.KDEC(4).EQ.14) THEN
            IF(KDEC(23).LE.1) THEN
               J=0
               DO 101 I=1,23
               J=J+1 
               ITBTRA(J)=ITBTRL(I)
 101           CONTINUE 
C
               J=J+1
               ITBTRA(J)=ITBTRL(24)
               J=J+1
               ITBTRA(J)=ITBTRL(25)
               J=J+1
               ITBTRA(J)=ITBTRL(26)
               J=J+1
               ITBTRA(J)=ITBTRL(27)
C     
               GO TO 110
C
            END IF

         END IF
C     -----------------------------------------------------------------  
         IERR=1
         RETURN
C     -----------------------------------------------------------------
C
 110     CONTINUE
C
         DO 111 I=1,J
C
         ITR=ITBTRA(I)
C
         DO 112 II=1,JP2
C
         IF(ITR.EQ.NTABBTR(II)) THEN
            IWTR (I)=NTABBTR(II)
            IWTS (I)=NTABBS (II)
            IWTDW(I)=NTABBDW(II)
            IWTRV(I)=NTABBRV(II)
            CUNIT(I)=CTABBU(II)
            GO TO 111
         END IF
C
 112     CONTINUE
C
       PRINT*,'BUFR TABLE B REFERENCE ENTRY',ITR,'NOT FOUND'
C
 111     CONTINUE
C
      END IF
C
      END
	SUBROUTINE SETTAB( IERR )
C
C**** *SETTAB*
C
C
C     PURPOSE.
C     --------
C         PURPOSE OF THIS ROUTINE IS TO SET *BUFR *TABLES *B.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *SETTAB(IERR)*
C
C     AUTHOR.
C     -------
C
C          M. D. DRAGOSAVAC    *ECMWF*       17/09/87.
C
C
C     MODIFICATIONS.
C     --------------
C
C          R.CINTRA
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      PARAMETER(JSUP =   9,JSEC0=   3,JSEC1= 40,JSEC2= 64 ,JSEC3=    4,
     1          JSEC4=   2,JELEM=20000,JSUBS=400,JCVAL=150 ,JBUFL= 8192,
     2          JBPW =  32,JTAB =1000,JCTAB=120,JCTST=1800,JCTEXT= 200,
     3          JWORK=80000,JKEY=46) 
     
      COMMON /BCOMTAB/ NTABBTR(JTAB),NTABBS (JTAB),NTABBRV(JTAB),
     1                NTABBDW(JTAB),NTABDTR(JTAB),NTABDST(JTAB),
     2                NTABDL (JTAB),NTABDSQ(JTAB*20),NTABP(64,255)
C
C             NTABBTR    - table B,  table reference              array
C             NTABBS     - table B,  scale                        array
C             NTABBRF    - table B,  reference value              array
C             NTABBDW    - table B,  data width                   array
C             NTABDTR    - table D,  table reference              array
C             NTABDST    - table D,  starting pointers            array
C             NTABDL     - table D,  lengths                      array
C             NTABDSQ    - table D,  list of sequence descriptors array
C
C
      COMMON /BCOMTABC / CTABBEN(JTAB),CTABBU (JTAB)
C
C             CTABBEN      -  table B, ELEMENT NAME           array
C             CTABBU       -  table B, unit                   array
C
C
C      COMMON /BCOMCT/ NREF(JCTAB)   ,NSTART(JCTAB) ,NLEN(JCTAB),
C     1               NCODNUM(JCTST),NSTARTC(JCTST),
C     2               NLENC(JCTST)
C
C             NREF      - table C reference
C             NSTART    - starting pointers to array NCODNUM
C             NLEN      - lengths
C             NCODNUM   - code/flag table number
C             NSTARTC   - starting pointers to array CTEXT
C             NLENC     - lengths
C
C
C      COMMON /BCOMCTC/ CTEXT(JCTEXT)
C
C             CTEXT     - text in code/flag tables
C
C
      COMMON /BCOMROOT/ CROOT
C
C            CROOT    -  path for Bufr tables
C
C
      CHARACTER*256 YTAB ,YTAC ,YTAD
      CHARACTER*11  YTABB,YTABC,YTABD
      CHARACTER    CTABBEN*64,CTABBU*24,CTEXT*64
      CHARACTER*256 CROOT
      
C     ------------------------------------------------------------------
C
C*          1.   GET BUFR TABLES/LOCAL BUFR TABLES.
C                ----------------------------------
 100  CONTINUE
C
      IF( KERR.NE.0) RETURN
C
C*          2.   SET UP BUFR TABLE FILE NAME.
C                ----------------------------
 200  CONTINUE
C
C
C             BUFR EDITION 2 NAMING CONVENTION
C
C             BXXXXXYYZZ , CXXXXXYYZZ , DXXXXXYYZZ
C
C             B      - BUFR TABLE 'B'
C             C      - BUFR TABLE 'C'
C             D      - BUFR TABLE 'D'
C             XXXXX  - ORIGINATING CENTRE
C             YY     - VERSION NUMBER OF MASTER TABLE
C                      USED( CURRENTLY 2 )
C             ZZ     - VERSION NUMBER OF LOCAL TABLE USED
C
C             BUFR EDITION 3 NAMING CONVENTION
C
C             BWWWXXXYYZZ , CWWWXXXYYZZ , DWWWXXXYYZZ
C
C             B      - BUFR TABLE 'B'
C             C      - BUFR TABLE 'C'
C             D      - BUFR TABLE 'D'
C             WWW    - ORIGINATING SUB-CENTRE
C             XXX    - ORIGINATING CENTRE
C             YY     - VERSION NUMBER OF MASTER TABLE
C                      USED( CURRENTLY 2 )
C             ZZ     - VERSION NUMBER OF LOCAL TABLE USED
C
C
            IXX=46
            IYY=02
            IZZ=01
            IWW=0
C
         NXXP=IXX
         NYYP=IYY
         NZZP=IZZ
         NWWP=IWW
C
            WRITE(YTABB,'(A1,I5.5,I2.2,I2.2)') 'B',IXX,IYY,IZZ
C            WRITE(YTABC,'(A1,I5.5,I2.2,I2.2)') 'C',IXX,IYY,IZZ
            WRITE(YTABD,'(A1,I5.5,I2.2,I2.2)') 'D',IXX,IYY,IZZ
C
c         PRINT*,'BUFR Tables to be loaded ',YTABB,',',YTABC,',',YTABD
          PRINT*,'BUFR Tables to be loaded ',YTABB,',',YTABD
C
C     ----------------------------------------------------------------
C*          3. OPEN AND READ FILES CONTAINING BUFR TABLES.
C              -------------------------------------------
 300  CONTINUE
C
      I=INDEX(CROOT,' ')
      IF(I.GT.1) I=I-1
C
C*          3.1 READ BUFR TABLE B.
C               ------------------
 310  CONTINUE
C
      YTAB=CROOT(1:I)//YTABB
      II=I+11
C
      OPEN(UNIT=38,IOSTAT=IOS,ERR=410,FILE=YTAB(1:II),
     1     FORM='UNFORMATTED',
     2     ACCESS='SEQUENTIAL',
     5     STATUS='OLD')
C
      READ(38,ERR=400,IOSTAT=IOS) NTABBTR,CTABBEN,CTABBU,NTABBS,
     1                            NTABBRV,NTABBDW,NTABP
C
      CLOSE(UNIT=38,IOSTAT=IOS,ERR=420)
C
C*          3.3 READ BUFR TABLE D.
C               ------------------
      
 330  CONTINUE
C
      YTAD=CROOT(1:I)//YTABD
C
      OPEN(UNIT=40,IOSTAT=IOS,ERR=610,FILE=YTAD(1:II),
     1     FORM='UNFORMATTED',
     2     ACCESS='SEQUENTIAL',
     5     STATUS='OLD')
C
      READ(40,ERR=600,IOSTAT=IOS) NTABDTR,NTABDL,NTABDST,NTABDSQ
C
      CLOSE(UNIT=40,IOSTAT=IOS,ERR=620)
C
C
      RETURN
C     ----------------------------------------------------------------
      
C
 400  CONTINUE
C
      KERR=6
      PRINT*,'SETTAB: IOS ',IOS
      RETURN
C
 410  CONTINUE
C
      KERR=9
      PRINT*,'SETTAB: IOS ',IOS
      RETURN
C
 420  CONTINUE
C
      KERR=10
      PRINT*,'SETTAB: IOS ',IOS
      RETURN
C     -----------------------------------------------------------------
 600  CONTINUE
C
      KERR=8
      PRINT*,'SETTAB: IOS ',IOS
      RETURN
C
 610  CONTINUE
C
      KERR=9
      PRINT*,'SETTAB: IOS ',IOS
      RETURN
C
 620  KERR=12
      PRINT*,'BUGBTS: IOS ',IOS
      RETURN
C     -----------------------------------------------------------------
C      
      end      
      SUBROUTINE KTOMPSI(IA)
C
C**** *KTOMPSI*
C
C
C     PURPOSE.
C     --------
C
C         CONVERTS KNOTS TO METRES PER SECOND, ROUNDING
C         TO NEAREST METRE.
C
C         INPUT    :  IA WIND SPEED IN KNOTS (INTEGER)
C
C         OUTPUT   :  IA WIND SPEED IN M/S (INTEGER)
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *KTOMPSI(IA)*
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
C
C
C     MODIFICATIONS.
C     --------------
C
C          R.CINTRA
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C     ------------------------------------------------------------------
C
C*          1.   CONVERT WIND IN KNOTS TO METER PER SECOND .
C                -------------------------------------------
 100  CONTINUE
C
C
      IA=NINT(0.5148 * IA +0.5)
      RETURN
      END
      FUNCTION P(Z)
C
      DATA A/5.252368255329/, B/44330.769230769/
      DATA  C/0.000157583169442/
      DATA  PTRO/226.547172/, PO/1013.25/
C
      IF (Z.GT.11000.) GO TO 50
      Y = 1.-Z/B
      P = PO*(Y**A)
      RETURN
C
50    Y = -C*(Z-11000.)
      P = PTRO*EXP(Y)
      RETURN
      END
c............................................................................
	SUBROUTINE DATUM(IDD,IMM,IYY)
C
C**** *DATUM*
C
C
C     PURPOSE.
C     --------
C         DEFINE PROPER MONTH AND YEAR IF DAY IS DEFINED.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *DATUM(IDD,IMM,IYY)*
C                       IDD - DAY
C                       IMM - MONTH
C                       IYY - YEAR
C
C     METHOD.
C     -------
C
C          IF IDD IS GREATER THAN CURRENT DAY DAY IS CONSIDERED TO BE FROM
C          PREVIOUS MONTH.IF CURRENT MONTH IS JANUARY
C          YEAR BECOMS PREVIOUS ONE.
C          IF IDD IS LESS OR EQUALL THAN CURRENT DAY IT IS FROM CURRENT MONTH
C          AND YEAR.
C
C
C
C     EXTERNALS.
C     ----------
C
C         *CALL* *daTIM(YDTIME)*
C
C     AUTHOR.
C     -------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
C
C     MODIFICATIONS.
C     --------------
C
C          R. CINTRA.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      include 'comdate.h'
      CHARACTER*3 YMONTH(12)
      integer iyear,imonth,iday,iutc,ihour,imin,isec,imili          
C
      DATA YMONTH/'Jan','Feb','Mar','Apr','May','Jun','Jul',
     1            'Aug','Sep','Oct','Nov','Dec'/
C
C     ------------------------------------------------------------------
C*          1.   GET DATE FROM THE SYSTEM.
C                -------------------------
 100  CONTINUE
C
      
c      CALL datim(iyear,imonth,iday,iutc,ihour,imin,isec,imili)
       iyear = ny
       imonth = nm
       iday = nd
       ihour = nh
       imin = nmin
       isec = nsec
c       print*,iyear,imonth,iday,ihour,imin,isec
C
C*          1.1  DEFINE MONTH AND YEAR
C                ---------------------
 110  CONTINUE
C
      
      IF(IDAY.GE.IDD) THEN
         IMM=IMONTH
         IYY=IYEAR
         ima=imonth
         RETURN
      END IF
C
      IF(IDAY.LT.IDD) THEN
         IF(IMONTH.EQ.1) THEN
            IMM=12
            IYY=IYEAR-1
            RETURN
         END IF
         IMM=IMONTH-1
         IYY=IYEAR
      END IF     
C
      RETURN
      END
      
      SUBROUTINE datim(date_time)
C
C     This subroutine returns a interger array (8)
C       where:  value1 = 4-digit year
c		value2 = month of the year
c		value3 = day of the year
c		value4 = time difference to UTC in minutes.
c		value5 = hour of the day ( range 0 to 23)
c		value6 = minutes of the hour ( range 0 to 59)
c		value7 = seconds of the range ( range 0 to 59)
c		value8 = miliseconds of the second ( range 0 to 999)		
C 
      include 'comdate.h'
    
      integer date_time (8)
      character*12  real_clock(3)
      CHARACTER*3 YMONTH(12)      
C
      DATA YMONTH/'Jan','Feb','Mar','Apr','May','Jun','Jul',
     1            'Aug','Sep','Oct','Nov','Dec'/
C----------------------------------------------------------------
C    Caso seja fornecido um argumento sera usado caso contrario
C    pegara a data do sistema
C----------------------------------------------------------------
               integer k,iargc
               CHARACTER*12 arg
               external getarg,iargc
               k=iargc()
               call getarg(k , arg)
               
      if (k .lt. 2 )   then      
               
 	CALL date_and_time(real_clock(1),real_clock(2),real_clock(3),
     c   date_time)
      else
c             PRINT*,'Passando a data ', arg
             
             read(arg(1:4),'(i4.4)') ny
             read(arg(5:6),'(i2.2)') nm
             read(arg(7:8),'(i2.2)') nd
             read(arg(9:10),'(i2.2)') nh
             read(arg(11:12),'(i2.2)') nmin
             nutc = 0
             nsec = 0
             ncc = 0
             date_time(1) = ny
             date_time(2) = nm
             date_time(3) = nd
             date_time(4) = nutc
             date_time(5) = nh
             date_time(6) = nmin
             date_time(7) = nsec
             date_time(8) = ncc
             
      end if
c      print*,ny,nm,nd,nutc,NH,NMIN,NSEC,ncc
c             PRINT*,'Passando a data'
c             write(date_time(1),'(A)')arg(1:4)
c             write(date_time(2),'(A)')arg(5:6)
c             write(date_time(2),'(A)')arg(7:8)
c             date_time(4) = 0
c             write(date_time(2),'(A)')arg(9:10)
c             write(date_time(2),'(A)')arg(11:12) 
c             date_time(7) = 0
c             date_time(8) = 0
c      end if
c      print*,date_time
C----------------------------------------------------------------
      RETURN
      END
















































